Package: spatialFDA
Title: A Tool for Spatial Multi-sample Comparisons
Version: 1.5.1
Authors@R: c(
    person("Martin", "Emons", , "martin.emons@uzh.ch", role = c("aut", "cre"),
           comment = c(ORCID = "0009-0000-5219-5311")),
    person("Samuel", "Gunz", ,role="aut",
           comment = c(ORCID = "0000-0002-8909-0932")),
    person("Fabian", "Scheipl", , role="aut",
            comment = c(ORCID = "0000-0001-8172-3603")),
    person("Elizabeth", "Purdom", , role="aut",
            comment = c(ORCID = "0000-0001-9455-7990")),
    person("Mark D.", "Robinson", , "mark.robinson@mls.uzh.ch", role = c("aut", "fnd"),
           comment = c(ORCID = "0000-0002-3048-5518")))
URL: https://github.com/mjemons/spatialFDA
BugReports: https://github.com/mjemons/spatialFDA/issues
Description: spatialFDA is a package to calculate spatial statistics metrics. 
            The package takes a SpatialExperiment object and calculates spatial statistics metrics using the package spatstat.
            Then it compares the resulting functions across samples/conditions using functional additive models as implemented in the package refund. 
            Furthermore, it provides exploratory visualisations using functional principal component analysis, as well implemented in refund.
License: GPL (>= 3) + file LICENSE
Encoding: UTF-8
Depends: R (>= 4.3.0)
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
Imports: dplyr, ggplot2, parallel, patchwork, purrr, refund,
        SpatialExperiment, spatstat.explore, spatstat.geom,
        SummarizedExperiment, methods, stats, fda, tidyr, graphics,
        ExperimentHub, scales, S4Vectors, mgcv
biocViews: Software, Spatial, Transcriptomics
VignetteBuilder: knitr
Suggests: stringr, knitr, rmarkdown, BiocStyle, testthat (>= 3.0.0)
Config/testthat/edition: 3
git_url: https://git.bioconductor.org/packages/spatialFDA
git_branch: devel
git_last_commit: 0a191f4
git_last_commit_date: 2026-08-21
Repository: Bioconductor 3.24
Date/Publication: 2026-08-21
NeedsCompilation: no
Packaged: 2026-08-22 00:42:48 UTC; biocbuild
Author: Martin Emons [aut, cre] (ORCID:
    <https://orcid.org/0009-0000-5219-5311>),
  Samuel Gunz [aut] (ORCID: <https://orcid.org/0000-0002-8909-0932>),
  Fabian Scheipl [aut] (ORCID: <https://orcid.org/0000-0001-8172-3603>),
  Elizabeth Purdom [aut] (ORCID: <https://orcid.org/0000-0001-9455-7990>),
  Mark D. Robinson [aut, fnd] (ORCID:
    <https://orcid.org/0000-0002-3048-5518>)
Maintainer: Martin Emons <martin.emons@uzh.ch>

<!-- README.md is generated from README.Rmd. Please edit that file -->

# spatialFDA

[![R-CMD-check](https://github.com/mjemons/spatialFDA/actions/workflows/R-CMD-check.yaml/badge.svg?branch=devel)](https://github.com/mjemons/spatialFDA/actions/workflows/R-CMD-check.yaml)

<img src="inst/extdata/spatialFDA.png" style="width:20.0%" />

spatialFDA is a tool to calculate spatial statistics functions on a
`SpatialExperiment` object using the `spatstat` library. It contains
functions to plot these spatial statistics functions. In addition, users
can compare the statial statistics functions using functional data
analysis. Here, we use the `refund` library.

## Installation

You can install the official released `Bioconductor` version of
`spatialFDA` via

``` r
if (!require("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("spatialFDA")
```

You can install the development version of `spatialFDA` from
[GitHub](https://github.com/) with:

``` r
# install.packages("devtools")
devtools::install_github("mjemons/spatialFDA")
```

## Disclaimer

This package is still under active development, the content is therefore
subject to change. Please refer to the `Bioconductor` releases for
stable versions.

AI coding assistants were used for parts of this package.

## Contact

In case you have suggestions to `spatialFDA` please consider opening an
issue to this repository.

## Citation

When using `spatialFDA` please cite our pre-print

    @article {Emons2026.04.13.718197,
        author = {Emons, Martin and Scheipl, Fabian and Gunz, Samuel and Purdom, Elizabeth and Robinson, Mark D},
        title = {Differential co-localisation analysis of multi-sample and multi-condition experiments with spatialFDA},
        year = {2026},
        doi = {10.64898/2026.04.13.718197},
        publisher = {Cold Spring Harbor Laboratory},
        journal = {bioRxiv}
    }

# `spatialFDA` package sticker

* package:[URL](http://bioconductor.org/packages/spatialFDA)
* Maintainer: [Martin Emons](https://github.com/mjemons/)
* License: Creative Commons Attribution
[CC-BY](https://creativecommons.org/licenses/by/4.0/)

<img src=spatialFDA.png height="200">

The data used to generate the outputs `gcross.csv` `lcross_single.csv` and `lcross.csv` comes from an `ExperimentHub` entry by Damond et al. (2023). The raw data to this entry can be accessed on Mendeley Data `https://data.mendeley.com/datasets/cydmwsfztj/2` published under a CC-BY-4.0 license Damond et al. (2020) with the associated publication `https://doi.org/10.1016/j.cmet.2018.11.014` by Damond et al. (2019).

link: `https://creativecommons.org/licenses/by/4.0/deed.en`

#' Plot a spatial metric per field of view
#'
#' A function that plots the output of the function `calcMetricPerFov`. The plot
#' contains one curve per FOV and makes subplots by samples.
#'
#' @param metricDf the metric `dataframe` as calculated by `calcMetricPerFov`
#' @param theo logical; if the theoretical line should be plotted
#' @param correction the border correction to plot
#' @param x the x-axis variable to plot
#' @param imageId the ID of the image/fov
#' @param ID the (optional) ID for plotting combinations
#' @param nrow the number of rows for the facet wrap
#' @param ncol the number of columns for the facet wrap
#' @param legend.position the position of the legend of the plot
#' @param ... Other parameters passed to `ggplot2` functions
#'
#' @return a `ggplot` object
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#' # ceate a unique plotting ID
#' metricRes$ID <- paste0(
#'  metricRes$patient_stage, "|", metricRes$patient_id
#' )
#'
#' p <- plotMetricPerFov(metricRes,
#'     correction = "rs", x = "r",
#'     imageId = "image_number", ID = "ID"
#' )
#' print(p)
#' @import dplyr ggplot2
#' @importFrom methods is
plotMetricPerFov <- function(metricDf, theo = FALSE, correction = NULL,
    x = NULL, imageId = NULL, ID = NULL, nrow = NULL, ncol = NULL,
    legend.position = "none", ...) {
    # type checking
    stopifnot(is(metricDf, "data.frame"))
    stopifnot(is(correction, "character"))
    stopifnot(is(x, "character"))
    p <- ggplot(metricDf, aes(
        x = .data[[x]], y = .data[[correction]],
        group = factor(.data[[imageId]])
    ))
    if (!is.null(ID)) {
        p <- p +
            geom_line(aes(colour = factor(.data[[ID]])), ...) +
            facet_wrap(vars(.data[["selection"]], .data[[ID]]), nrow, ncol)
    } else {
        p <- p +
            geom_line(aes(colour = factor(.data[[imageId]])), ...)
    }
    p <- p +
        theme_minimal() +
        theme(legend.position = legend.position) +
        labs(title = paste0(
            metricDf$fun, " metric for ",
            unique(metricDf$selection)
        ))
    if (theo == TRUE) {
        p <- p + geom_line(aes(x = .data[[x]], y = theo),
            linetype = "dashed", color = "black", ...
        )
    }
    return(p)
}

#' Creates a nXn plot of the cross metrics per sample
#'
#' Helper function for `plotCrossMetricPerFov`. It applies `plotMetricPerFov`
#' to all `n` marks defined in the variable `selection`. This gives an
#' `nxn` plot of all marks.
#'
#' @param subFov a subset of the `dataframe` to the respective fov
#' @param theo logical; if the theoretical line should be plotted
#' @param correction the border correction to plot
#' @param x the x-axis variable to plot
#' @param imageId the ID of the image/fov
#' @param ID the (optional) ID for plotting combinations
#' @param nrow the number of rows for the facet wrap
#' @param ncol the number of columns for the facet wrap
#' @param legend.position the position of the legend of the plot
#' @param ... Other parameters passed to `ggplot2` functions
#'
#' @return a ggplot object
#' @export
#'
#' @importFrom methods is
plotCrossFOV <- function(subFov, theo, correction, x, imageId, ID = NULL,
                         ncol = NULL, nrow = NULL,
                         legend.position = "none", ...) {
    # type checking
    stopifnot(is(subFov, "data.frame"))
    #  Apply plot metric function for each combination
    lp <- lapply(unique(subFov$selection), function(sel) {
        plotMetricPerFov(
            metricDf = subFov[subFov$selection == sel, ],
            theo = theo, correction = correction, x = x,
            imageId = imageId, ID = ID, nrow = nrow, ncol = ncol,
            legend.position = legend.position, ...
        )
    })
    #  Count number of marks
    nMarks <- length(unique(subFov$selection))
    # Wraps the plot in an nXn grid
    p <- patchwork::wrap_plots(lp, ncol = sqrt(nMarks)) +
        patchwork::plot_layout(guides = "collect") &
        theme(legend.position = "bottom")
    return(p)
}


#' Plot a cross type spatial metric per field of view
#'
#' This function plots the cross function between two marks output from
#' `calcMetricPerFov`. It wraps around helper function and applies this
#' function to all samples.
#'
#' @param metricDf the metric dataframe as calculated by `calcMetricPerFov`
#' @param theo logical; if the theoretical line should be plotted
#' @param correction the border correction to plot
#' @param x the x-axis variable to plot
#' @param imageId the ID of the image/fov
#' @param ID the (optional) ID for plotting combinations
#' @param nrow the number of rows for the facet wrap
#' @param ncol the number of columns for the facet wrap
#' @param legend.position the position of the legend of the plot
#' @param ... Other parameters passed to `ggplot2` functions
#'
#' @return a ggplot object
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcCrossMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#'
#' metricRes$ID <- paste0(
#'  metricRes$patient_stage, "|", metricRes$patient_id
#' )
#'
#' metricRes <- subset(metricRes, image_number %in% c(138, 139, 140))
#' p <- plotCrossMetricPerFov(metricRes,
#'     theo = TRUE, correction = "rs",
#'     x = "r", imageId = "image_number", ID = "ID"
#' )
#' print(p)
#' @importFrom methods is
plotCrossMetricPerFov <- function(
        metricDf,
        theo = NULL,
        correction = NULL,
        x = NULL,
        imageId = NULL,
        ID = NULL,
        nrow = NULL,
        ncol = NULL,
        legend.position = "none",
        ...) {
    # type checking
    stopifnot(is(metricDf, "data.frame"))
    stopifnot(is(imageId, "character"))
    # Find all unique samples
    samples <- metricDf[[imageId]] |> unique()

    # Applies the function abouve to all samples
    resP <- lapply(samples, function(fov) {
        subFov <- metricDf[metricDf[[imageId]] %in% fov, ]
        return(plotCrossFOV(
            subFov = subFov, theo = theo, correction = correction,
            x = x, imageId = imageId, ID = ID, nrow = nrow, ncol = ncol,
            legend.position = legend.position, ...
        ))
    })

    return(resP)
}

#' Functional boxplot of spatstat curves
#'
#' This function creates a functional boxplot of the spatial statistics curves.
#' It creates one functional boxplot per aggregation category, e.g. condition.
#'
#' @param metricDf the metric dataframe as calculated by `calcMetricPerFov`
#' @param x the name of the x-axis of the spatial metric
#' @param y the name of the y-axis of the spatial metric
#' @param imageId the ID of the image/fov
#' @param sampleId the ID of the sample
#' @param aggregateBy the criterion by which to aggregate the curves into a
#' functional boxplot. Can be e.g. the condition of the different samples.
#'
#' @return a list of base R plots
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#' # create a unique ID for the data preparation
#' metricRes$ID <- paste0(
#'   metricRes$patient_stage, "|", metricRes$patient_id,
#'   "|", metricRes$image_number
#' )
#'
#' plotFbPlot(metricRes, 'r', 'rs', 'patient_stage', 'patient_id',
#'  'image_number')
#' @importFrom fda fbplot
#' @importFrom graphics title
plotFbPlot <- function(
    metricDf, x, y, aggregateBy, sampleId,
    imageId) {
  aggregationLs <- metricDf[[aggregateBy]] %>% unique
  ylim <- c(min(metricDf[[y]]), max(metricDf[[y]]))
  lapply(aggregationLs, function(aggregate){
      filteredData <- metricDf %>% filter(.data[[aggregateBy]] == aggregate)
      res <- prepData(filteredData, x, y, sampleId, imageId) %>% tidyr::drop_na()
      fda::fbplot(t(res$Y), ylim = ylim)
      graphics::title(main = aggregate)
    })
}

#' Statistical Inference on Spatial Statistics Functions
#'
#' A function to perform spatial statistical inference on spatial omics data.
#' This function works so far only on functions of radius "r".
#'
#' @param spe a `SpatialExperiment` object
#' @param selection the mark(s) you want to compare. NOTE: This is directional.
#' c(A,B) is not the same result as c(B,A).
#' @param fun the `spatstat` function to compute on the point pattern object
#' @param marks the marks to consider e.g. cell types
#' @param rSeq the range of r values to compute the function over
#' @param correction the edge correction to be applied
#' @param sample_id the spe `colData` variable to mark the sample, if not NULL
#' this will result in a mixed model estimation
#' @param image_id the spe `colData` variable to mark the image
#' @param condition the spe `colData` variable to mark the condition
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param assay the assay which is used if `continuous = TRUE`
#' @param transformation the transformation to be applied as exponential e.g.
#' 1/2 for sqrt or Fisher's variance-stabilising transformation if "Fisher"
#' @param intensityAdjustment a logical whether or not to normalise out cell 
#' type intensity differences in the functional regression model.
#' For $L$ functions the intensity effects is already explicit in the metric 
#' definition. The intensity adjustement is via the average intensity of the 
#' query cell type B in a cross (A->B) setting parametrised as a constant 
#' covariate over the domain $r$. The "default" normalises $G$ and $F$ functions
#' like this but not all other functions.  
#' @param weights the weighting to be applied to the functional GAM. Either NULL
#' (equal weights), total (npoints of total pattern), min (npoints of the smaller
#' subpattern) or max (npoints of the larger subpattern) or a user defined value
#' of same length as the number of curves to be estimated
#' @param eps some distributional families fail if the response is zero,
#' therefore, zeros can be replaced with a very small value eps
#' @param delta the delta value to remove from the beginning of the spatial
#' statistics functions. Can be reasonable if e.g. cells are always spaced
#' by 10 µm. If set to "minNnDist" it will take the mean of the minimum nearest
#' neighbour distance across all images for this cell type pair.
#' @param family the distributional family for the functional GAM
#' @param ncores the number of cores to use for parallel processing, default = 1
#' @param verbose logical indicating whether to print all information or not
#' @param upperDeltaProb the quantile to filter out the constant 1 part for `Gest`
#' and `Gcross`. If `NULL` no upper filtering is applied.
#' @param weightTransform logical indicating whether the weights (number of points) 
#' should be sqrt transformed
#' @param AR1 logical indicating whether to calculate the autocorrelation of the 
#' residuals along the domain and account for this in a second fitting step
#' @param sandwich string indicating how and if to adjust for heterscedasticity of the 
#' residuals with a sandwich correction
#' @param algorithm algorithm to fit the refund::pffr method. defaults to `bam`
#' @param ... Other parameters passed to `spatstat.explore` functions for
#' parameters concerning the spatial function calculation and to `refund::pffr`
#' for the functional additive mixed model inference
#'
#' @returns a list with four objects: i) the dataframe with the spatial
#' statistics results transformed and filtered as used for fitting,
#' ii) the raw spatial statistics results, iii) the designmatrix of the
#' inference and iv) the fitted pffr object v) the residual standard error per
#' condition defined as the residual sum of squares divided by the number of
#' datapoints - sum of the estimated degrees of freedom for the model parameters
#'  as well as other QC metrics
#'
#' @export
#'
#' @examples
#' spe <- .loadExample()
#' #make the condition a factor variable
#' colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#' #relevel to have non-diabetic as the reference category
#' colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
#' "Non-diabetic")
#' res <- spatialInference(spe, c("alpha", "Tc"),
#'     fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), correction = "rs",
#'     sample_id = "patient_id",
#'     image_id = "image_number", condition = "patient_stage",
#'     ncores = 1,
#'     algorithm = "bam"
#' )
spatialInference <- function(spe,
                             selection,
                             fun,
                             marks = NULL,
                             rSeq = NULL,
                             correction,
                             sample_id,
                             image_id,
                             condition,
                             continuous = FALSE,
                             assay = "exprs",
                             transformation = NULL,
                             intensityAdjustment = "default",
                             weights = "total",
                             eps = 1e-3,
                             delta = "minNnDist",
                             family = stats::gaussian(link = "log"),
                             verbose = TRUE,
                             upperDeltaProb = NULL,
                             weightTransform = TRUE,
                             AR1 = FALSE,
                             sandwich = "cluster",
                             ncores = 1,
                             algorithm = "bam",
                             ...){
  #for computational reasons, remove the assays as we don't need them
  SummarizedExperiment::assays(spe) <- list()
  #for computational reasons, remove the rowData as we don't need them
  SummarizedExperiment::rowData(spe) <- S4Vectors::DataFrame(row.names = rownames(spe))
  #small assertion that the condition has to be a factor
  stopifnot(is(colData(spe)[[condition]], "factor"))

  #the default behaviour is that G and F functions are intensity corrected in
  #the model and all others not
  if(intensityAdjustment == "default"){
    if(fun %in% c("Gest", "Fest", "Gcross", "Fcross")){
      intensityAdjustment <- TRUE
    }else{
      intensityAdjustment <- FALSE
    }
  }

  if(!is.null(sample_id)){
    by <- c(sample_id, image_id, condition)
  }else{
    by <- c(image_id, condition)
  }

  #first, run calcMetricPerFov
  metricResRaw <- calcMetricPerFov(spe = spe,
                                selection = selection,
                                subsetby = image_id,
                                fun = fun,
                                marks =marks,
                                rSeq = rSeq,
                                by = by,
                                verbose = verbose,
                                ncores = ncores,
                                correction = correction,
                                ...
  )

  #second, build the dataframes for pffr and designmatrix
  #the model definitions etc should come from calcMetricPerFov in principle and
  #one of those has to be a factor with correct levels
  if(!is.null(sample_id)){
    metricResRaw$ID <- paste0(
      metricResRaw[[condition]], "|", metricResRaw[[sample_id]],
      "|", metricResRaw[[image_id]]
    )
  }else{
    metricResRaw$ID <- paste0(
      metricResRaw[[condition]], "|",
      "|", metricResRaw[[image_id]]
    )
  }

  noConditionsPreFiltering <- (length(unique(metricResRaw[[condition]])))
  if(!correction %in% colnames(metricResRaw)){
    if(verbose){
      message("Can not fit a model if one condition has no images with curves")
    }
    mdl = NULL
    mm = NULL
    QCDf = NULL
    #return pffr object and calcMetricPerFov dataframe in a named list
    return(list(metricRes = metricResRaw,
                designmat = mm,
                mdl = mdl,
                curveFittingQC = QCDf))
    
  }
  # #removing field of views that have as a curve only zeros - these are cases where
  # #there is no cells of one type
  metricRes <- metricResRaw %>% dplyr::group_by(.data[["ID"]]) %>%
    dplyr::filter(sum(.data[[correction]]) >= 1)

  #filter the upper part of the curve 
  if(!is.null(upperDeltaProb) && (fun == "Gest" || fun == "Gcross")){
    res <-metricRes |> 
      filter(round(.data[[correction]], 2) == 1) |> 
      group_by(.data[["ID"]]) |> 
      mutate(lowerRQuartile = stats::quantile(r, probs = upperDeltaProb))
    res2 <- metricRes |>
      filter(round(.data[[correction]], 2) != 1 & r == max(rSeq)) |>
      group_by(.data[["ID"]]) |>
      mutate(lowerRQuartile =  max(rSeq))
    res <- rbind(res, res2)
    upperDelta <- stats::median(res$lowerRQuartile)
    metricRes <- metricRes %>% filter(r < upperDelta)
  }

  # if a transformation should be applied to the output
  if(!is.null(transformation)){
    if(transformation == "Fisher"){
      metricRes[[correction]] <- pmax(asin(sqrt(metricRes[[correction]])),
                                      eps)
    }else{
    stopifnot(is(transformation, "numeric"))
    metricRes[[correction]] <- pmax((metricRes[[correction]])^(transformation),
                                    eps)
    }
  }
  # else just set zeros to eps if lower than eps.
  else if(!is.null(eps)){
    metricRes[[correction]] <- pmax(metricRes[[correction]], eps)
  }

  if(delta == "minNnDist"){
    delta <- stats::weighted.mean(x=metricRes[["minDist"]],
                                  w = metricRes[["npoints"]])
  }


  metricRes <- metricRes %>% filter(r >= delta)
  noConditionsPostFiltering <- (length(unique(metricRes[[condition]])))
  if(noConditionsPreFiltering == noConditionsPostFiltering){
    # prepare data for FDA
    dat <- prepData(metricRes, "r", correction, sample_id,
                    image_id, condition)

    # drop rows with NA
    dat <- dat |> drop_na()
    #create the designmatrix - condition needs to be a factor with the correct
    #level at position one for the reference category
    conditionVariable <- condition
    condition <- dat[[condition]]
    if(verbose){
      message(paste0("Creating design matrix with ", levels(condition)[[1]],
                 " as reference"))
    }
    mm <- stats::model.matrix(~condition)
    #make sure that the colnames don't have "-" instead of "_"
    colnames(mm) <- gsub("-","_", colnames(mm))
    #create a formula without the first intercept column
    formula <- stats::as.formula(paste("Y ~", paste(colnames(mm)[c(-1)],
                                                    collapse="+")), env = emptyenv())

    if(!is.null(sample_id)){
      formula <- stats::as.formula(paste("Y ~",
                                  paste(c(colnames(mm)[c(-1)],
                                          paste0("s(",sample_id,", bs = 're')")),
                                        collapse="+")), env = emptyenv())
    }

    #due to the removal of delta, rSeq can be less as well
    r <- metricRes$r |> unique()

    # define the weights
    if(is.null(weights)){
      # give each observation weight one if no weights are passed
      weights = seq.int(from = 1, to = 1, length.out = nrow(dat))
    }else if(weights == "total"){
      weights = dat$npoints
    }else if(weights == "min"){
      weights = dat$npointsmin
    }else if(weights == "max"){
      weights = dat$npointsmax
    }else{
      stopifnot(length(weights) == nrow(dat))
      weights = weights
    }

    if(weightTransform){
      weights = sqrt(weights)
    }

    if(intensityAdjustment){
      if(fun %in% c("Lcross", "Lest", "Kcross", "Kest")){
        warning("Proportion offset included with ", fun, " that already
        normalises for proportion differences in the metric definition")
      }
      formula <- stats::update.formula(
        formula,
        . ~ . + c(intensityQuery)
      )
    }
    
    if(AR1){
      #if there is an AR1 correlation parameter given, fit first a model and compute the median ACF 
      #of the residuals
      mdl <- functionalGam(
        data = dat, x = r,
        designmat = mm, weights = weights,
        formula = formula,
        family = family,
        algorithm = algorithm,
        sandwich = sandwich,
        ...
      )
      if(algorithm == "gamm4"){
        mdl = mdl$gam
      }
      #compute median ACF for a lag of 1
      rho_est <- apply(stats::resid(mdl), 1, function(x) stats::acf(x, plot = FALSE)$acf[2]) |> 
        stats::median(na.rm = TRUE)
      #refit with estimated residual autocorrelation
      mdl <- functionalGam(
        data = dat, x = r,
        designmat = mm, weights = weights,
        formula = formula,
        family = family,
        rho = rho_est,
        algorithm = algorithm,
        sandwich = sandwich,
        ...
      )
    }else{
      mdl <- functionalGam(
        data = dat, x = r,
        designmat = mm, weights = weights,
        formula = formula,
        family = family,
        algorithm = algorithm,
        sandwich = sandwich,
        ...
      )
    }
    
    if(algorithm == "gamm4"){
      mdl = mdl$gam
    }
    
    ### Calculation of metrics assessing the quality of the model fit

    # adj R-squared of the entire model
    Rsq.adj <- summary(mdl, re.test = FALSE)$r.sq
    if(verbose){
      message(paste0("The adjusted R-squared of the model is ", Rsq.adj))
    }

    ##rename the conditions to be the same as in the summary output
    dat <- dat %>%
      mutate(coefficient =
               paste0("condition",
                      gsub("-","_", .data[[conditionVariable]]),"(x)")) %>%
      #rename the reference category to be Intercept
      mutate(coefficient =
               case_when(coefficient ==
                           paste0("condition",
                                  gsub("-","_",levels(condition)[[1]]), "(x)")
                         ~ "Intercept(x)", TRUE ~ coefficient))

    # calculate the median intensity per condition
    dfIntensity <- dat %>%
      group_by(.data[["coefficient"]]) %>%
      mutate(medianMinIntensity = stats::median(.data[["minIntensity"]])) %>%
      select(.data[["coefficient"]], .data[["medianMinIntensity"]]) %>%
      unique()

    #another QC metric of the model fit is inspecting the residuals per condition
    #we compare the residual standard error which is the sqrt residual sum of
    #squares divided by the degrees of freedom of the residuals per condition

    #we need condition specific residual degrees of freedom
    #take the rows of dat as this is filtered. Since we need to have not only
    #the number of curves but also the values per curve, we multiply nrow of dat
    #with the length of the functional domain r

    #Furthermore, we need to get condition specific estimated degrees of freedom
    #of the model parameters. These are in the model summary

    df.edf <- summary(mdl, re.test = FALSE)[["s.table"]] %>% as.data.frame()

    #if it is a mixed model, we need to remove the random effect column
    if(!is.null(sample_id)){
      #filter out sample_id
      df.edf <- df.edf %>% filter(!grepl(sample_id, rownames(df.edf)))
      #filter out image_id
      df.edf <- df.edf %>% filter(!grepl(image_id, rownames(df.edf)))
    }
    #this assumes that the order of the levels is the same as the order of the
    #summary output
    df.edf[["coefficient"]] <- rownames(df.edf)

    #select only the edf and the condition variable
    df.edf <- df.edf %>% select(.data[["edf"]], .data[["coefficient"]])

    #subtract from each condition wise number of curves * number of datapoints
    #per curve the condition wise edf from the summary(mdl) output above

    df.residual <- dat %>%
      group_by(.data[["coefficient"]]) %>%
      summarise(no.datapoints = n() * length(r)) %>%
      left_join(df.edf, by = "coefficient") %>%
      mutate(df.residual.condition = .data[["no.datapoints"]] - .data[["edf"]])

    #now we extract the residuals

    residualPffr <- as.data.frame(stats::residuals(mdl))
    residualPffr[[conditionVariable]] <- dat[[conditionVariable]]

    residualPffr <- residualPffr %>%
      mutate(coefficient = paste0("condition",
                                  gsub("-","_",
                                       .data[[conditionVariable]]),"(x)")) %>%
      #rename the reference category to be Intercept
      mutate(coefficient = case_when(coefficient == paste0("condition",
                                                           gsub("-","_",
                                                                levels(condition)[[1]]), "(x)")
                                     ~ "Intercept(x)",
                                     TRUE ~ coefficient))
    # combine the residuals with the degrees of freedom
    residualPffr <- residualPffr %>% left_join(df.residual, by = "coefficient")
    #calculate the grouped RSS and divide by the grouped condition wise residuals
    #and take the sqrt of this
    residualDf <- residualPffr %>%
      group_by(.data[["coefficient"]]) %>%
      reframe(residual_standard_errors = sqrt(sum(across(where(is.numeric) &
                                                           !c(.data[["df.residual.condition"]],
                                                              .data[["edf"]],
                                                              .data[["no.datapoints"]]))**2)
                                               /.data[["df.residual.condition"]]),
              edf = .data[["edf"]]) %>%
      unique()

    #assemble all QC scores
    QCDf <- residualDf %>%
      left_join(dfIntensity, by = "coefficient")

  }else{
    if(verbose){
      message("Can not fit a model if one condition has no images with curves")
    }
    mdl = NULL
    mm = NULL
    QCDf = NULL
  }

  #return pffr object and calcMetricPerFov dataframe in a named list
  return(list(metricRes = metricRes,
              designmat = mm,
              mdl = mdl,
              curveFittingQC = QCDf))
}

# load the pancreas dataset
library("tidyr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()

#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
                                           "Non-diabetic")
res <- spatialInference(spe, c("alpha"),
                        fun = "Gest", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

mdl1 <- res$mdl

resLs <- crossSpatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

mdl2 <- resLs$alpha_alpha$mdl

test_that("cross function with one element is identical to the single
          function call", {
  expect_true(identical(mdl1$coefficients, mdl2$coefficients))
})

res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

mdl3 <- res$mdl

mdl4 <- resLs$alpha_Tc$mdl

test_that("cross function with one element is identical to the single
          function call", {
            expect_true(identical(mdl3$coefficients, mdl4$coefficients))
          })

test_that("cross function with one element is identical to the single
          function call in the residuals", {
            expect_true(identical(mdl3$residuals, mdl4$residuals))
          })

# load the pancreas dataset
library("tidyr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and Tc cells
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Gcross", marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
                              c("patient_stage", "patient_id", "image_number"), ncores = 1
)

metricRes$ID <- paste0(
  metricRes$patient_stage, "x", metricRes$patient_id,
  "x", metricRes$image_number
)
#removing field of views that have as a curve only zeros - these are cases where
#there is no cells of one type
metricRes <- metricRes %>% dplyr::group_by(ID) %>% dplyr::filter(sum(rs) >= 1)

dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
                image_id = "image_number", condition = "patient_stage")

#' # drop rows with NA
dat <- dat |> drop_na()

# create a designmatrix
condition <- dat$patient_stage
# relevel the condition - can set explicit contrasts here
condition <- relevel(condition, "Non-diabetic")
designmat <- model.matrix(~condition)
# colnames don't work with the '-' sign
colnames(designmat) <- c(
  "(Intercept)", "conditionLong_duration",
  "conditionOnset"
)
# fit the model
mdl1 <- functionalGam(
  data = dat, x = metricRes$r |> unique(),
  designmat = designmat, weights = dat$npoints,
  formula = formula(Y ~ conditionLong_duration +
                      conditionOnset + s(patient_id, bs = "re")),
  family = gaussian(link = "identity"),
  algorithm = "bam",
  discrete = FALSE
)

## do the same with spatialInference

#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
                                           "Non-diabetic")
res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        intensityAdjustment = FALSE,
                        algorithm = "bam", discrete = FALSE,
                        eps = NULL, delta = 0, family = stats::gaussian(link = "identity"),
                        AR1 = FALSE, weightTransform = FALSE, sandwich = FALSE
)

mdl2 <- res$mdl

test_that("wrapper function gives same result as manual computation", {
  expect_true(identical(mdl1$coefficients, mdl2$coefficients))
})

resBeta <- spatialInference(spe, "beta",
                        fun = "Gest", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

test_that("spatialInference handels case when one condition has no images with
          calculated curves ", {
  expect_true(is.null(resBeta$mdl) && is.null(resBeta$designmat))
})

res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        weights = "min",
                        weightTransform = FALSE,
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

#order
metricRes <- res$metricRes %>% arrange(patient_id)

manual_weights <- metricRes$npointsmin / mean(metricRes$npointsmin)

modelframe <- res$mdl$model %>% arrange(patient_id)

test_that("weights of the model are really the min weights expected", {
  expect_equal(sort(modelframe$`(weights)`), sort(manual_weights))
})

res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        weights = "max",
                        weightTransform = FALSE,
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

#order
metricRes <- res$metricRes %>% arrange(patient_id)

manual_weights <- metricRes$npointsmax / mean(metricRes$npointsmax)

modelframe <- res$mdl$model %>% arrange(patient_id)

test_that("weights of the model are really the max weights expected", {
  expect_equal(sort(modelframe$`(weights)`), sort(manual_weights))
})

res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        weights = NULL,
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

#order
metricRes <- res$metricRes %>% arrange(patient_id)

manual_weights <- seq.int(from = 1, to = 1, length.out = nrow(metricRes))

modelframe <- res$mdl$model %>% arrange(patient_id)

test_that("weights of the model are equal weight", {
  expect_equal(sort(modelframe$`(weights)`), sort(manual_weights))
})

test_that("edf values correspond between RSE and mdl summary",{
  mdlEdf <-  as_tibble(summary(res$mdl, re.test = FALSE)$s.table[,"edf"])
  expect_true(
    sum(drop_na(res$curveFittingQC[,"edf"]) ==
         mdlEdf) == nrow(drop_na(res$curveFittingQC))
  )
})

#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
                                           "Onset")

res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        weights = NULL,
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        algorithm = "bam", discrete = TRUE
)

test_that("edf values correspond between RSE and mdl summary as well
          after permutation of levels",{
  mdlDf <-  (as_tibble(summary(res$mdl, re.test = FALSE)$s.table))
  mdlDf$coefficient <- rownames(summary(res$mdl, re.test = FALSE)$s.table)
  mdlDf$coefficient[mdlDf$coefficient == "c(s(image_number))"] <- "s(image_number)"
  mdlDf <- mdlDf %>% arrange(coefficient)

  mdlEdf <- as_tibble(mdlDf[,"edf"])
  expect_true(
    sum(drop_na(res$curveFittingQC[,"edf"]) ==
         mdlEdf) == nrow(drop_na(res$curveFittingQC))
  )
          })

test_that("spatialInference runs with different spline bases",{
  res <- spatialInference(spe, c("alpha", "Tc"),
                        fun = "Gcross", marks = "cell_type",
                        rSeq = seq(0, 50, length.out = 50), correction = "rs",
                        sample_id = "patient_id",
                        weights = NULL,
                        image_id = "image_number", condition = "patient_stage",
                        ncores = 1,
                        bs.yindex = list(bs = "tp", k = 7, m = c(2, 1)),
                        bs.int = list(bs = "tp", k = 25, m = c(2, 1)),
                        algorithm = "bam", discrete = TRUE
)
  expect_true(!is.null(res$mdl) && !is.null(res$designmat))
})

test_that("spatilInference can handle completely missing points",{
  res <- spatialInference(spe, c("beta", "B"),
    fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), correction = "rs",
    sample_id = "patient_id",
    image_id = "image_number", condition = "patient_stage",
    ncores = 1,
    algorithm = "bam"
  )
  expect_true(is.null(res$mdl) && is.null(res$designmat))
})

test_that("spatilInference works with intensity covariate adjustement",{
  res <- spatialInference(spe, c("alpha", "Tc"),
    fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), correction = "rs",
    sample_id = "patient_id",
    image_id = "image_number", condition = "patient_stage",
    ncores = 1,
    algorithm = "bam",
    intensityAdjustment = TRUE
  )
  expect_true(!is.null(res$mdl))
})

#' Heuristic for the choice of rMax
#' @param spe a `SpatialExperiment` object
#' @param subsetby the spe `colData` variable to subset the data by. This
#' variable has to be provided, even if there is only one sample.
#' @param marks the marks to consider e.g. cell types
#'
#' @returns a ggplot histogram of the bounding radius of all the
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' p <- rMaxHeuristic(spe,
#' subsetby = "image_number", marks = "cell_type"
#' )
rMaxHeuristic <- function(spe, subsetby, marks){
  #create a dataframe
  df <- .speToDf(spe)
  #split the dataframe
  dfLs <- base::split(df, df[[subsetby]])
  radiusDf <- lapply(dfLs, function(dfSub){
    pp <- .dfToppp(dfSub, marks = marks)
    return(data.frame("bounding_radius" = spatstat.geom::boundingradius(pp)))
  }) %>% dplyr::bind_rows()
 rMax <- min(radiusDf[["bounding_radius"]]) / 2
 p <- ggplot(radiusDf, aes(.data[["bounding_radius"]])) +
   geom_histogram(binwidth = (10), boundary=0) +
   theme_light() +
   geom_vline(xintercept = rMax, color = "red") +
   xlab("minimum bounding radius") +
   ggtitle(paste0("heuristic rMax is ", rMax))
 return(p)
}

#' Reshaping the Result of a Cross Spatial Inference to a Dataframe
#'
#' @param resLs a list with four objects: i) the dataframe with the spatial
#' statistics results transformed and filtered as used for fitting,
#' ii) the raw spatial statistics results, iii) the designmatrix of the
#' inference and iv) the fitted pffr object v) the residual standard error per
#' condition defined as the residual sum of squares divided by the number of
#' datapoints - sum of the estimated degrees of freedom for the model parameters
#'  as well as other QC metrics
#' @param QCMetric the metric to relate the quality of the fit too.
#' @param QCThreshold the threshold on the QC metric. Depends
#' on the function used.
#'
#' @returns a dataframe for plotting with ggplot2
#' @export
#'
#' @examples
#' spe <- .loadExample()
#' #make the condition a factor variable
#' colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#' #relevel to have non-diabetic as the reference category
#' colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
#' "Non-diabetic")
#'
#' selection <- c("acinar", "ductal")
#' resLs <- crossSpatialInference(spe, selection,
#'                       fun = "Gcross", marks = "cell_type",
#'                       rSeq = seq(0, 50, length.out = 50), correction = "rs",
#'                       sample_id = "patient_id",
#'                       image_id = "image_number", condition = "patient_stage",
#'                       algorithm = "bam",
#'                       ncores = 1
#'                   )
#' df <- extractCrossInferenceData(resLs)
extractCrossInferenceData <- function(resLs,
                                      QCMetric = "medianMinIntensity",
                                      QCThreshold = 0.1){
  df <- lapply(names(resLs), function(x){
    mdl <- resLs[[x]]$mdl
    QCDf <- resLs[[x]]$curveFittingQC
    metricRes <- resLs[[x]]$metricRes
    metricResRaw <- resLs[[x]]$metricResRaw
    if(!is.null(mdl)){
      table <- summary(mdl, re.test = FALSE)$s.table %>% as.data.frame()

      #in case that discrete = TRUE we have to reformat the data
      rownames(table) <- gsub("\\x\\.", "(x)", rownames(table))
      rownames(table) <- gsub("NA.", "character(0)", rownames(table))

      table$coefficient <- rownames(table)
      table$combination <- x
      table <- table %>% separate(.data[["combination"]],
                                  c("cell1", "cell2"), sep = "_")
      #extract the mean functional coefficient as effect size measure
      coef <- coef(mdl)
      df <- lapply(rownames(table), function(predictor){
        df <- coef$sm[[predictor]]$coef
        df[["coefficient"]] <- predictor
        df <- df %>% mutate(mean_coefficient = mean(.data[["value"]])) %>%
          select(.data[["mean_coefficient"]], .data[["coefficient"]]) %>%
          unique()
        return(df)
      }) %>% dplyr::bind_rows()
      #join by coefficient
      table <- table %>% dplyr::left_join(df, by = "coefficient")  %>%
        dplyr::left_join(QCDf, by = "coefficient")
      #binarise the QC metric
      table <- table %>%
        mutate(QCBin =
                 if_else(.data[[QCMetric]] <= QCThreshold,
                         paste0(QCMetric, " <= ", QCThreshold),
                         paste0(QCMetric, " > ", QCThreshold))
        )
      return(table)
    }
  }) %>% dplyr::bind_rows()
  return(df)
}

#' Plotting the Result of a Cross Spatial Inference
#'
#' @param resLs a list with four objects: i) the dataframe with the spatial
#' statistics results transformed and filtered as used for fitting,
#' ii) the raw spatial statistics results, iii) the designmatrix of the
#' inference and iv) the fitted pffr object v) the residual standard error per
#' condition defined as the residual sum of squares divided by the number of
#' datapoints - sum of the estimated degrees of freedom for the model parameters
#'  as well as other QC metrics
#' @param adj.pvalue a pvalue adjustment method as passed to stats::p.adjust
#' defaults to Benjamini-Hochberg correction of the false discovery rate.
#' @param coefficientsToPlot list of which coefficients to plot in the heatmap
#' defaults to NULL in which case all coefficients are plotted
#' @param QCMetric the metric to relate the quality of the fit too.
#' @param QCThreshold the threshold on the Quality control metric. Depends
#' on the function used.
#' @param ... other parameters passed to `ggplot2` functions
#'
#' @returns a ggplot2 object
#' @export
#'
#' @examples
#' spe <- .loadExample()
#' #make the condition a factor variable
#' colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#' #relevel to have non-diabetic as the reference category
#' colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
#' "Non-diabetic")
#'
#' selection <- c("acinar", "ductal")
#' resLs <- crossSpatialInference(spe, selection,
#'                       fun = "Gcross", marks = "cell_type",
#'                       rSeq = seq(0, 50, length.out = 50), correction = "rs",
#'                       sample_id = "patient_id",
#'                       image_id = "image_number", condition = "patient_stage",
#'                       algorithm = "bam",
#'                       ncores = 1
#'                   )
#' p <- plotCrossHeatmap(resLs, adj.pvalue = "BH")
#'
plotCrossHeatmap <- function(resLs,
                             adj.pvalue = "BH",
                             coefficientsToPlot = NULL,
                             QCThreshold = 1e-5,
                             QCMetric = "medianMinIntensity",
                             ...){
 df <- extractCrossInferenceData(resLs = resLs,
                                 QCMetric = QCMetric,
                                 QCThreshold = QCThreshold)
 #make below QC bin NA so that we can colour it as black later on
 df[["mean_coefficient"]] = ifelse(df[["QCBin"]] ==
                                     paste0(QCMetric," > ", QCThreshold),
                                   df[["mean_coefficient"]], NA_real_)
 if(!is.null(coefficientsToPlot)){
   df <- df %>% filter(.data[["coefficient"]] %in% coefficientsToPlot)
 }
 if(is.null(adj.pvalue)){
   p <- ggplot(df, aes(x = .data[["cell1"]], y = .data[["cell2"]])) +
     geom_point(aes(size = -log10(.data[["p-value"]] + 0.001),
                    shape = .data[["QCBin"]],
                    color = .data[["mean_coefficient"]]))+
     geom_point(aes(size = -log10(.data[["p-value"]] + 0.001)),
                    shape = 1, colour = "black")
 }else{
   df[["adj.p-value"]] <- stats::p.adjust(df[["p-value"]], method = adj.pvalue)
   p <- ggplot(df, aes(x = .data[["cell1"]], y = .data[["cell2"]])) +
     geom_point(aes(size = -log10(.data[["adj.p-value"]] + 0.001),
                    shape = .data[["QCBin"]],
                    color = .data[["mean_coefficient"]]))+
     geom_point(aes(size = -log10(.data[["adj.p-value"]] + 0.001)),
                shape = 1,colour = "black")
 }
 p <- p + scale_x_discrete(guide = guide_axis(angle = 50))
 if(any(df[["QCBin"]] == paste0(QCMetric," <= ", QCThreshold), na.rm = TRUE)){
   p <- p + scale_shape_manual(values = c(13,16))
 }else{
   p <- p + scale_shape_manual(values = c(16,13))
 }

 p <- p + facet_wrap(~.data[["coefficient"]]) +
   theme_light() +
   scale_colour_gradient2(midpoint = 0,
                          high = scales::muted("red"),
                          mid = "white",
                          low = scales::muted("blue"),
                          na.value = "black")
 return(p)
}

#' load Example dataset from Damond et al. (2019)
#'
#' @param full a boolean indicating whether to load the entire
#' Damond et al. (2019) or only a subset
#'
#' @returns A SpatialExperiment object as uploaded to `ExperimentHub()`
#' @export
#'
#' @examples
#' # retrieve the Damond et al. (2019) dataset
#' spe <- .loadExample()
#'
#' @importFrom ExperimentHub ExperimentHub
.loadExample <- function(full = FALSE) {
   # retrieve data from EH directly - code adapted from `imcdatasets`
   # Damond et.al (2023) licensed under GPLv3
   # (https://www.gnu.org/licenses/gpl-3.0.txt)
   eh <- ExperimentHub::ExperimentHub()
   if(full){
     title = "Damond_2019_Pancreas - sce - v1 - full"
   }
   else{
     title = "Damond_2019_Pancreas - sce - v1"
   }
   object_id <- eh[eh$title == title]$ah_id
   sce <- eh[[object_id]]
   # rename coordinates
   colData(sce)$x <- colData(sce)$cell_x
   colData(sce)$y <- colData(sce)$cell_y
   # create SPE object
   spe <- toSpatialExperiment(sce,
                              sample_id = "image_name",
                              spatialCoordsNames = c("x", "y"))
   return(spe)
}

#' Convert SpatialExperiment object to ppp object
#'
#' @param df A dataframe with the x and y coordinates from the corresponding
#' SpatialExperiment and the ColData
#' @param marks A vector of marks to be associated with the points, has to be
#' either named 'cell_type' if you want to compare discrete celltypes or else
#' continous gene expression measurements are assumed as marks.
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param window An observation window of the point pattern of class `owin`.
#' @return A ppp object for use with `spatstat` functions
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' speSub <- subset(spe, , image_number == "138")
#' dfSub <- .speToDf(speSub)
#' pp <- .dfToppp(dfSub, marks = "cell_type")
#'
#' @importFrom SummarizedExperiment colData
#' @importFrom methods is
.dfToppp <- function(df, marks = NULL, continuous = FALSE, window = NULL) {
    #type checking
    stopifnot(is(df, "data.frame"))
    # this definition of the window is quite conservative
    # - can be set explicitly
    pp <- spatstat.geom::as.ppp(data.frame(x = df$x, y = df$y),
        W = spatstat.geom::owin(
            c(
                base::min(df$x) - 1,
                base::max(df$x) + 1
            ),
            c(
                base::min(df$y) - 1,
                base::max(df$y) + 1
            )
        )
    )
    # set the marks
    if (!continuous) {
        spatstat.geom::marks(pp) <- factor(df[[marks]])
    } else {
        spatstat.geom::marks(pp) <- base::subset(df, select =
                                                   names(df) %in% marks)
    }
    # if window exist, set is as new window and potentially exclude some points
    if (!is.null(window)) {
        pp <- spatstat.geom::as.ppp(spatstat.geom::superimpose(pp, W = window))
    }

    return(pp)
}

#' Transform a SpatialExperiment into a dataframe
#'
#' @param spe A SpatialExperiment object subset to a single image
#'
#' @return A dataframe with the x and y coordinates from the corresponding
#' SpatialExperiment and the colData
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' speSub <- subset(spe, , image_number == "138")
#' dfSub <- .speToDf(speSub)
#' @importFrom methods is
.speToDf <- function(spe) {
    stopifnot(is(spe, "SpatialExperiment"))
    df <- data.frame(
        x = SpatialExperiment::spatialCoords(spe)[, 1],
        y = SpatialExperiment::spatialCoords(spe)[, 2]
    )
    df <- cbind(df, colData(spe))
}

# load the pancreas dataset
library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and Tc cells
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Gcross",
                              marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
                              c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "x", metricRes$patient_id,
  "x", metricRes$image_number
)
# prepare data for FDA
dat <- prepData(metricRes, "r", "rs")

# drop rows with NA
dat <- dat |> drop_na()

# create meta info of the IDs
splitData <- str_split(dat$ID, "x")
dat$condition <- factor(sapply(splitData, function(x) x[1]))
dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
dat$image_id <- factor(sapply(splitData, function(x) x[3]))
# create a designmatrix
condition <- dat$condition
# relevel the condition - can set explicit contrasts here
condition <- relevel(condition, "Non-diabetic")
designmat <- model.matrix(~condition)
# colnames don't work with the '-' sign
colnames(designmat) <- c(
  "(Intercept)", "conditionLong_duration",
  "conditionOnset"
)
# fit the model
mdl <- functionalGam(
  data = dat, x = metricRes$r |> unique(),
  designmat = designmat, weights = dat$npoints,
  formula = formula(Y ~ conditionLong_duration +
                      conditionOnset + s(patient_id, bs = "re")),
  algorithm = "bam"
)

test_that("Output is of correct type", {
  expect_equal(is(mdl), "functionalGam")
  expect_true(!is.null(mdl$coefficients))
  expect_true(!is.null(mdl$residuals))
  expect_true(!is.null(mdl$weights))
  expect_true(!is.null(mdl$fitted.values))
})

test_that("Fails if designmat and formula arguments don't correspond", {
  expect_error(functionalGam(
    data = dat, x = metricRes$r |> unique(),
    designmat = designmat, weights = dat$npoints,
    formula = formula(Y ~ conditionLong_duration_diabetes +
                        conditionOnset_diabetes + s(patient_id, bs = "re")),
    algorithm = "bam"
  ))
})

test_that("Can handle missingnis in response - still functionalGam object", {
  dat[1, 2][9] <- NA
  mdl <- functionalGam(
    data = dat, x = metricRes$r |> unique(),
    designmat = designmat, weights = dat$npoints,
    formula = formula(Y ~ conditionLong_duration +
                        conditionOnset + s(patient_id, bs = "re")),
    algorithm = "bam"
  )
  expect_equal(is(mdl), "functionalGam")
  expect_true(!is.null(mdl$coefficients))
  expect_true(!is.null(mdl$residuals))
  expect_true(!is.null(mdl$weights))
  expect_true(!is.null(mdl$fitted.values))
})

test_that("Should fail if weights contain NA", {
  dat$npoints[1] <- NA
  expect_error(functionalGam(
    data = dat, x = metricRes$r |> unique(),
    designmat = designmat, weights = dat$npoints,
    formula = formula(Y ~ conditionLong_duration +
                        conditionOnset + s(patient_id, bs = "re")),
    algorithm = "bam"
  ))
})

library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and Tc cells
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Gcross",
                              marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
                              c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "x", metricRes$patient_id,
  "x", metricRes$image_number
)
# prepare data for FDA
dat <- prepData(metricRes, "r", "rs")

# drop rows with NA
dat <- dat |> drop_na()
# create meta info of the IDs
splitData <- str_split(dat$ID, "x")
dat$condition <- factor(sapply(splitData, function(x) x[1]))
dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
dat$image_id <- factor(sapply(splitData, function(x) x[3]))
# calculate fPCA
mdl <- functionalPCA(
  data = dat, r = metricRes$r |> unique()
)

test_that("Correct output type", {
  # of the correct type
  expect_equal(is(mdl), "fpca")
  # contains the required output
  expect_true(!is.null(mdl$Yhat))
  expect_true(!is.null(mdl$scores))
  expect_true(!is.null(mdl$efunctions))
  expect_true(!is.null(mdl$evalues))
  expect_true(!is.null(mdl$npc))
  expect_true(!is.null(mdl$pve))
})

test_that("Can handle NA in response", {
  dat[1, 2][9] <- NA
  mdl <- functionalPCA(
    data = dat, r = metricRes$r |> unique()
  )
  expect_equal(is(mdl), "fpca")
  # contains the required output
  expect_true(!is.null(mdl$Yhat))
  expect_true(!is.null(mdl$scores))
  expect_true(!is.null(mdl$efunctions))
  expect_true(!is.null(mdl$evalues))
  expect_true(!is.null(mdl$npc))
  expect_true(!is.null(mdl$pve))
})

#' Plot a pffr model object
#'
#' A function that takes a pffr object as calculated in `functionalGam` and
#' plots the functional coefficients. The functions are centered such that their
#' expected value is zero. Therefore, the scalar intercept has to be added to
#' the output with the argument `shift` in order to plot the coefficients in
#' their original range.
#'
#' @param mdl a `pffr` model object
#' @param predictor predictor to plot
#' @param shift the value by which to shift the centered functional intercept.
#' this will most often be the constant intercept
#'
#' @return ggplot object of the functional estimate
#' @export
#'
#' @examples
#' library("tidyr")
#' library("stringr")
#' library("dplyr")
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#' # create a unique ID for each row
#' metricRes$ID <- paste0(
#'     metricRes$patient_stage, "x", metricRes$patient_id,
#'     "x", metricRes$image_number
#' )
#'
#' dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
#'     image_id = "image_number", condition = "patient_stage")
#'
#'#' # drop rows with NA
#' dat <- dat |> drop_na()
#'
#' # create a designmatrix
#' condition <- dat$patient_stage
#' # relevel the condition - can set explicit contrasts here
#' condition <- relevel(condition, "Non-diabetic")
#' designmat <- model.matrix(~condition)
#' # colnames don't work with the '-' sign
#' colnames(designmat) <- c(
#'     "(Intercept)", "conditionLong_duration",
#'     "conditionOnset"
#' )
#' # fit the model
#' mdl <- functionalGam(
#'     data = dat, x = metricRes$r |> unique(),
#'     designmat = designmat, weights = dat$npoints,
#'     formula = formula(Y ~ conditionLong_duration +
#'         conditionOnset + s(patient_id, bs = "re")),
#'         algorithm = "bam"
#' )
#' summary(mdl, re.test = FALSE)
#' plotLs <- lapply(colnames(designmat), plotMdl,
#'     mdl = mdl,
#'     shift = mdl$coefficients[["(Intercept)"]]
#' )
#' @import dplyr
#' @importFrom methods is
plotMdl <- function(mdl, predictor, shift = NULL) {
    # type checking
    stopifnot(is(mdl, "pffr"))
    stopifnot(is(predictor, "character"))
    # extract the coefficients from the model
    coef <- coef(mdl)
    if (predictor == "(Intercept)" && !is.null(shift)) {
        #rename as pffr output is without brackets
        predictor = "Intercept"
        coef$smterms[["Intercept(x)"]]$coef$value <-
          coef$smterms[["Intercept(x)"]]$coef$value + shift
    }
    # get the actual values into a dataframe
    df <- coef$smterms[[paste0(predictor, "(x)")]]$coef
    # plot
    p <- ggplot(df, aes(.data$yindex.vec, .data$value)) +
        geom_line(linewidth = 1) +
        # here, I implement a Wald CI - could be improved
        geom_ribbon(
            data = df,
            aes(ymin = .data$value - 1.96 * .data$se,
                ymax = .data$value + 1.96 * .data$se),
            alpha = 0.3
        ) +
        geom_hline(
            yintercept = 0,
            linetype = "dashed", color = "red", linewidth = 1
        ) +
        ggtitle(predictor) +
        ylab("parameter value") +
        xlab("r") +
        theme_light()
    return(p)
}

#' Function for Cross Spatial Inference
#'
#' This function is a wrappere function around `spatialInference`. It calculates
#' `spatialInference` results either for all cell types in `marks`
#' (if `selection == NULL`) or for a custom subset defined in `selection`.
#'
#' @param spe a `SpatialExperiment` object
#' @param selection the mark(s) you want to compare. NOTE: This is directional.
#' c(A,B) is not the same result as c(B,A).
#' @param fun the `spatstat` function to compute on the point pattern object
#' @param marks the marks to consider e.g. cell types
#' @param rSeq the range of r values to compute the function over
#' @param correction the edge correction to be applied
#' @param sample_id the spe `colData` variable to mark the sample, if not NULL
#' this will result in a mixed model estimation
#' @param image_id the spe `colData` variable to mark the image
#' @param condition the spe `colData` variable to mark the condition
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param assay the assay which is used if `continuous = TRUE`
#' @param transformation the transformation to be applied as exponential e.g. 1/2 for sqrt
#' @param eps some distributional families fail if the response is zero,
#' therefore, zeros can be replaced with a very small value eps
#' @param delta the delta value to remove from the beginning of the spatial
#' statistics functions. Can be reasonable if e.g. cells are always spaced
#' by 10 µm. If set to "minNnDist" it will take the mean of the minimum nearest
#' neighbour distance across all images for this cell type pair.
#' @param family the distributional family for the functional GAM
#' @param verbose logical indicating whether to print all information or not
#' @param ncores the number of cores to use for parallel processing, default = 1
#' @param ... Other parameters passed to `spatstat.explore` functions for
#' parameters concerning the spatial function calculation and to `refund::pffr`
#' for the functional additive mixed model inference
#'
#' @returns a list of objects created by the function `spatialInference`
#' with three objects: i) the dataframe with the spatial
#' statistics results, ii) the designmatrix of the inference and iii) the
#' fitted pffr object
#' @export
#'
#' @examples
#' spe <- .loadExample()
#' #make the condition a factor variable
#' colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#' #relevel to have non-diabetic as the reference category
#' colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
#' "Non-diabetic")
#'
#' selection <- c("acinar", "ductal")
#' resLs <- crossSpatialInference(spe, selection, fun = "Gcross",
#'                       marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'                       correction = "rs", sample_id = "patient_id",
#'                       image_id = "image_number", condition = "patient_stage",
#'                       algorithm = "bam",
#'                       ncores = 1
#'                   )
#'
crossSpatialInference <- function(spe,
                                  selection = NULL,
                                  fun,
                                  marks = NULL,
                                  rSeq = NULL,
                                  correction,
                                  sample_id,
                                  image_id,
                                  condition,
                                  continuous = FALSE,
                                  assay = "exprs",
                                  transformation = NULL,
                                  eps =  1e-3,
                                  delta = "minNnDist",
                                  family = stats::gaussian(link = "log"),
                                  verbose = TRUE,
                                  ncores = 1,
                                  ...){
  #for computational reasons, remove the assays as we don't need them
  SummarizedExperiment::assays(spe) <- list()
  #for computational reasons, remove the rowData as we don't need them
  SummarizedExperiment::rowData(spe) <- S4Vectors::DataFrame(row.names = rownames(spe))
  #first, create a list of all the celltypes if selection = NULL
  if(is.null(selection)){
    selection <- colData(spe)[[marks]] %>% unique()
  }

  ### code adapted from calcCrossMetricPerFov written by Samuel Gunz
  ls <- apply(base::expand.grid(selection, selection), 1, function(x) {
    return(c(x[1], x[2]))
  }, simplify = FALSE)
  # calculate the metric per FOV
  resLs <- lapply(ls, function(x) {
    res <- spatialInference(spe = spe,
                           selection = x,
                           fun = fun,
                           marks = marks,
                           rSeq = rSeq,
                           correction = correction,
                           sample_id = sample_id,
                           image_id = image_id,
                           condition = condition,
                           continuous = continuous,
                           assay = assay,
                           transformation = transformation,
                           eps = eps,
                           delta = delta,
                           family = family,
                           verbose = verbose,
                           ncores = ncores,
                           ...)
    return(res)
  })
  mat <- do.call("cbind",ls) %>% t()
  cellTypes <- paste0(mat[,1], "_", mat[,2])
  names(resLs) <- cellTypes

  return(resLs)
}

## ----v1, include = FALSE------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    eval = TRUE
)

## ----installation, include = TRUE, eval = FALSE-------------------------------
# if (!requireNamespace("BiocManager")) {
#     install.packages("BiocManager")
# }
# BiocManager::install("spatialFDA")

## ----setup, warning = FALSE, message = FALSE----------------------------------
library("spatialFDA")
library("dplyr")
library("ggplot2")
library("tidyr")
library("stringr")
library("dplyr")
library("patchwork")
library("SpatialExperiment")

set.seed(1234)

## ----loading, warning = FALSE, message = FALSE--------------------------------
# retrieve example data from Damond et al. (2019)
spe <- .loadExample(full = TRUE)

spe <- subset(spe, ,patient_id %in% c(6089,6180,6126,6134,6228,6414))
# set cell types as factors
colData(spe)$cell_type <- as.factor(colData(spe)$cell_type) 

## ----plotting fovs, warning = FALSE, fig.width=8, fig.height=15---------------
df <- data.frame(spatialCoords(spe), colData(spe))

dfSub <- df %>%
    subset(image_name %in% c("E02", "E03", "E04", "E05"))

p <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_category)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell category")+
    coord_equal() +
    theme_light()

dfSub <- dfSub %>%
    subset(cell_type %in% c("alpha", "beta", "delta", "Th", "Tc"))

q <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_type)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell type") +
    coord_equal() +
    theme_light()
wrap_plots(list(p,q), widths = c(1,1), heights = c(1,1), nrow = 2, ncol = 1)

## -----------------------------------------------------------------------------
p <- rMaxHeuristic(spe,
subsetby = "image_number", marks = "cell_type"
)
p

## ----crossSpatialInference, results='hide', message = FALSE, warning = FALSE----
#relevel to have non-diabetic as the reference category
spe$patient_stage <- relevel(factor(spe$patient_stage), "Non-diabetic")

#run the spatial statistics inference
resLs <- crossSpatialInference(
    spe, 
    selection = c("alpha", "Tc"),
    fun = "Gcross", 
    marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), 
    correction = "rs",
    sample_id = "patient_id",
    image_id = "image_number", 
    condition = "patient_stage",
    intensityAdjustment = TRUE
)

names(resLs)

## ----bubblePlot, results='hide', message = FALSE, eval=TRUE-------------------
p <- plotCrossHeatmap(resLs, coefficientsToPlot = c("conditionLong_duration(x)", "conditionOnset(x)"), QCThreshold = 0, QCMetric = "medianMinIntensity")
p <- p + theme(legend.position = "bottom") + guides(shape = "none") + 
  facet_wrap(~factor(coefficient, levels = c("conditionOnset(x)", "conditionLong_duration(x)"), labels = c("conditionOnset(x)" = "Onset", "conditionLong_duration(x)" = "Long-Duration")))

p

## ----resSelection, eval=TRUE--------------------------------------------------
res <- resLs$alpha_Tc
names(res)

## ----plotFunction, message = FALSE, warning = FALSE---------------------------
#filtered and stabilised curves
metricRes <- res$metricRes

# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "rs", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)

## ----funcBoxPlot, warning = FALSE, results='hide'-----------------------------
# create a unique ID per row in the dataframe
metricRes$ID <- paste0(
    metricRes$patient_stage, "x", metricRes$patient_id,
    "x", metricRes$image_number
)

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")

## ----funcGamm-----------------------------------------------------------------
mdl <- res$mdl
mm <- res$designmat

summary(mdl, re.test = FALSE)

## ----plotFuncGamm-------------------------------------------------------------
plotLs <- lapply(colnames(mm), plotMdl, mdl = mdl,
                 shift = mdl$coefficients[["(Intercept)"]])
wrap_plots(plotLs, nrow = 3, axes = 'collect')

## ----contour, warning = FALSE-------------------------------------------------
residuals(mdl) |> cor() |> filled.contour(levels = seq(-1, 1, l = 40))
residuals(mdl) |> cov() |> filled.contour()

qqnorm(mdl$residuals, pch = 16)
qqline(mdl$residuals)

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

## ----v1, include = FALSE------------------------------------------------------
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    eval = TRUE
)

## ----installation, include = TRUE, eval = FALSE-------------------------------
# if (!requireNamespace("BiocManager")) {
#     install.packages("BiocManager")
# }
# BiocManager::install("spatialFDA")

## ----setup, warning = FALSE, message = FALSE----------------------------------
library("spatialFDA")
library("dplyr")
library("ggplot2")
library("tidyr")
library("stringr")
library("dplyr")
library("patchwork")
library("SpatialExperiment")

set.seed(1234)

## ----loading, warning = FALSE, message = FALSE--------------------------------
# retrieve example data from Damond et al. (2019)
spe <- .loadExample(full = TRUE)

spe <- subset(spe, ,patient_id %in% c(6089,6180,6126,6134,6228,6414))
# set cell types as factors
colData(spe)$cell_type <- as.factor(colData(spe)$cell_type) 

## ----plotting fovs, warning = FALSE, fig.width=8, fig.height=15---------------
df <- data.frame(spatialCoords(spe), colData(spe))

dfSub <- df %>%
    subset(image_name %in% c("E02", "E03", "E04", "E05"))

p <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_category)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell category")+
    coord_equal() +
    theme_light()

dfSub <- dfSub %>%
    subset(cell_type %in% c("alpha", "beta", "delta", "Th", "Tc"))

q <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_type)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell type") +
    coord_equal() +
    theme_light()
wrap_plots(list(p,q), widths = c(1,1), heights = c(1,1), nrow = 2, ncol = 1)

## -----------------------------------------------------------------------------
p <- rMaxHeuristic(spe,
subsetby = "image_number", marks = "cell_type"
)
p

## ----Lfunction, warning = FALSE, message = FALSE------------------------------
metricRes <- calcMetricPerFov(spe = spe, selection = c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Lcross", 
                              marks = "cell_type",
                              rSeq = seq(0, 50, length.out = 50), 
                              by = c("patient_stage", "patient_id",
                                     "image_number"),
                              ncores = 1)
metricRes %>% head(3)

## ----plotLfunction, warning = FALSE, fig.width=8, fig.height=8----------------
# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "iso", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)

## ----Gfunction, warning = FALSE, message = FALSE------------------------------
metricRes <- calcMetricPerFov(spe = spe, selection = c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Gcross", 
                              marks = "cell_type",
                              rSeq = seq(0, 50, length.out = 50), 
                              by = c("patient_stage", "patient_id",
                                     "image_number"),
                              ncores = 1)
metricRes %>% head(3)

## ----plotGfunction, warning = FALSE, fig.width=8, fig.height=8----------------
# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "rs", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)

## ----funcBoxPlot, warning = FALSE, results='hide'-----------------------------
# create a unique ID per row in the dataframe
metricRes$ID <- paste0(
    metricRes$patient_stage, "x", metricRes$patient_id,
    "x", metricRes$image_number
)
#removing field of views that have as a curve only zeros - these are cases where
#there is no cells of one type
metricRes <- metricRes %>% dplyr::group_by(ID) %>% dplyr::filter(sum(rs) >= 1)

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")

## ----variancetransform, warning = FALSE---------------------------------------
# can determine with a boxcox transformation what is the ideal parameter
# for the transformation use Fisher's variance-stabilising transformation
metricRes$rs <- asin(sqrt(metricRes$rs))

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")

## ----fPCA, warning = FALSE----------------------------------------------------
# filter out all rows that have a constant zero part - all r=<10
metricRes <- metricRes %>% filter(r >= 10)

# prepare dataframe from calcMetricRes to be in the correct format for pffr
dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
 image_id = "image_number", condition = "patient_stage")

dat$condition <- gsub("-","_", dat$patient_stage) %>% 
  as.factor() %>%
  relevel("Non_diabetic")

# drop rows with NA
dat <- dat |> drop_na()
# calculate the fPCA
pca <- functionalPCA(dat = dat, r = metricRes$r |> unique(), pve = 0.995)
evalues <- pca$evalues
efunctions <- pca$efunctions
# plot the mean curve and the two first eigenfunctions
p_mu <- ggplot(data.frame(r = unique(metricRes$r), mu = pca$mu), 
               aes(x = r, y = mu)) +
    geom_line() +
    theme_light() +
    xlab("r [µm]")

p_efunction1 <- ggplot(data.frame(r = unique(metricRes$r), 
                                  phi1 = pca$efunctions[,1]), 
                       aes(x = r, y = phi1)) +
    geom_line() +
    theme_light() +
    ylim(-0.3,0.3) +
    xlab("r [µm]")

p_efunction2 <- ggplot(data.frame(r = unique(metricRes$r),
                                  phi2 = pca$efunctions[,2]),
                       aes(x = r, y = phi2)) +
    geom_line() +
    theme_light() +
    ylim(-0.3,0.3) +
    xlab("r [µm]")

wrap_plots(list(p_mu, p_efunction1, p_efunction2), ncol = 3)
# plot the biplot of the first two PCs
plotFpca(dat = dat, res = pca, colourby = "condition")
# print the eigenvalues
evalues

## ----funcGamG, fig.height=10, warning = FALSE---------------------------------
library('refund')
# create a design matrix
mm <- model.matrix(~condition, data = dat)
mm %>% head()

r <- metricRes$r |> unique()
# fit the model
mdl <- functionalGam(
    data = dat, x = r,
    designmat = mm, weights = dat$npoints,
    formula = formula(Y ~ 1 + conditionLong_duration +
                          conditionOnset + s(patient_id, bs = "re")),
    family = mgcv::scat(link = "log"),
    algorithm = "bam"
)
summary(mdl)

plotLs <- lapply(colnames(mm), plotMdl, mdl = mdl,
                 shift = mdl$coefficients[["(Intercept)"]])
wrap_plots(plotLs, nrow = 3, axes = 'collect')

## ----contour, warning = FALSE-------------------------------------------------
resid(mdl) |> cor() |> filled.contour(levels = seq(-1, 1, l = 40))
resid(mdl) |> cov() |> filled.contour()

qqnorm(resid(mdl), pch = 16)
qqline(resid(mdl))

## ----intercept, warning = FALSE, eval = TRUE----------------------------------
# look at the smooth random intercepts per patient
data <- coef(mdl)$smterms$`character(0)`$coef

data <- data %>% left_join(dat %>% 
                             select(patient_id, condition) %>% unique)

p <- ggplot(data, aes(x = yindex.vec, y = value, colour = condition, group = patient_id)) +
  geom_line() +
  theme_light() + 
  geom_smooth(aes(group = 1), col = 'black') +
  xlab("r [µm]")

p

## ----sessionInfo--------------------------------------------------------------
sessionInfo()

#' General additive model with functional response
#'
#' A function that takes the output of a metric calculation as done by
#' `calcMetricPerFov`. The data has to be prepared into the correct format for
#' the functional analysis by the `prepData` function. The output is a `pffr`
#' object as implemented by `refund`.
#'
#' @param data a dataframe with the following columns: Y = functional response;
#' sample_id = sample ID; image_id = image ID;
#' @param x the x-axis values of the functional response
#' @param designmat a design matrix as defined by model.matrix()
#' @param weights weights as the number of points per image. These weights are
#' normalised by the mean of the weights in the fitting process
#' @param formula the formula for the model. The colnames of the designmatrix
#' have to correspond to the variables in the formula.
#' @param family the distributional family as implemented in `family.mgcv`. For
#' fast computation the default is set to `gaussian` with a log link.
#' other interesting options can be `betar` and `scat`
#'  - for more information see `family.mgcv`.
#' @param algorithm algorithm to fit the refund::pffr method. defaults to `bam`
#' @param sandwich string indicating how and if to adjust for heterscedasticity of the 
#' residuals with a sandwich correction
#' @param discrete option to discretise the function for faster computation. default is
#' `TRUE`. See `mgcv::bam` for more information. When using `gam`, this option has to be 
#' `FALSE`
#' @param bs.yindex a list specifying the spline bases for the index. See `refund::pffr`
#' for more details
#' @param bs.int a list specfying the spline bases for the global function intercept.
#'  See `refund::pffr` for more details
#' @param ... Other parameters passed to `pffr`
#'
#' @return a fitted pffr object which inherits from gam
#' @export
#'
#' @examples
#' # load the pancreas dataset
#' library("tidyr")
#' library("dplyr")
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' # calculate the Gcross metric for alpha and Tc cells
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross",
#'     marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'     c("patient_stage", "patient_id", "image_number"), ncores = 1
#' )
#' metricRes$ID <- paste0(
#'   metricRes$patient_stage, "|", metricRes$patient_id,
#'   "|", metricRes$image_number
#' )
#' dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
#'     image_id = "image_number", condition = "patient_stage")
#'
#'#' # drop rows with NA
#' dat <- dat |> drop_na()
#'
#' # create a designmatrix
#' condition <- dat$patient_stage
#' # relevel the condition - can set explicit contrasts here
#' condition <- relevel(condition, "Non-diabetic")
#' designmat <- model.matrix(~condition)
#' # colnames don't work with the '-' sign
#' colnames(designmat) <- c(
#'     "(Intercept)", "conditionLong_duration",
#'     "conditionOnset"
#' )
#' # fit the model
#' mdl <- functionalGam(
#'     data = dat, x = metricRes$r |> unique(),
#'     designmat = designmat, weights = dat$npoints,
#'     formula = formula(Y ~ conditionLong_duration +
#'         conditionOnset + s(patient_id, bs = "re")),
#'         algorithm = "bam"
#' )
#' summary(mdl)

#' @import dplyr
#' @importFrom methods is
#' @importFrom stats terms
functionalGam <- function(data, 
    x, 
    designmat, 
    weights, 
    formula,
    family = stats::gaussian(link = "log"),
    algorithm = "bam", 
    bs.yindex = list(bs = "ps", k = 5, m = c(2, 1)),
    bs.int = list(bs = "ps", k = 20, m = c(2, 1)),
    sandwich = "cluster",
    discrete = TRUE,
    ...) {
    # type checking
    stopifnot(is(data, "data.frame"))
    stopifnot(is(x, "vector"))
    stopifnot(is(designmat, "matrix"))
    stopifnot(is(weights, "numeric"), all(weights > 0))
    stopifnot(is(formula, "formula"))
    stopifnot(is(family, "character") || is(family, "family"))

    if(algorithm != "bam"){
        discrete = FALSE
        message("Algorithm is not `bam`, therefore setting
        `discrete` to FALSE")
    }

    data <- cbind(data, designmat)
    # Test that length of number of points and nrow of designmat correspond
    stopifnot(length(weights) == nrow(designmat))
    # normalise the weights
    weights <- weights / mean(weights)
    # Test that the colnames of the designmat correspond to formula
    # with the exception of the intercept as this is inferred - there are
    # functional and constant intercepts
    # deselect "Intercept"
    colNames <- colnames(designmat)[!colnames(designmat) %in% c("(Intercept)",
                                                                "Intercept")]
    # stop if the rest terms of design mat are not in the formula
    stopifnot(colNames %in% attr(terms(formula), "term.labels"))
    mdl <- refund::pffr(formula,
        yind = x,
        data = data,
        weights = weights,
        family = family,
        algorithm = algorithm,
        bs.yindex = bs.yindex,
        bs.int = bs.int,
        sandwich = sandwich,
        discrete = discrete,
        ...
    )
    #add functional GAM class for custom printing
    class(mdl) <- c("functionalGam", class(mdl))
    return(mdl)
}

#' Summary for functionalGam object
#'
#' @param object a fitted \code{functionalGam}-object
#' @param ... see \code{\link[mgcv]{summary.gam}()} for options.
#'
#' @return A list with summary information, see \code{\link[mgcv]{summary.gam}()}
#' @export
#' @method summary functionalGam
#' @importFrom mgcv summary.gam
#' @author Martin Emons, adapted from \code{\link[refund]{summary.pffr}()} by Fabian Scheipl
summary.functionalGam <- function(object, ...){
    call <- match.call()
    call[[1]] <- summary
    #need to remove functionalGam (similar to summary.pffr) in order
    #for the coef function to work correctly in summary.gam
    class(object) <- class(object)[!(class(object) %in% "functionalGam")]
    call$object <- as.name("object")
    ret <- eval(call)
  
    if(any(ret$s.table[,"p-value"] < 0) | any(ret$s.table[,"p-value"] > 1)){
        warning("p-values outside of [0,1]. Clipped to [0,1]")
        ret$s.table[, "p-value"] <- pmin(pmax(ret$s.table[, "p-value"], 0), 1)
    }
    # Rename (yindex) to (x) in row names of s.table and p.table
    if (!is.null(rownames(ret$s.table))) {
        rownames(ret$s.table) <- gsub("yindex", "x", rownames(ret$s.table))
    }
    if (!is.null(ret$p.table) && !is.null(rownames(ret$p.table))) {
        rownames(ret$p.table) <- gsub("yindex", "x", rownames(ret$p.table))
    }
    class(ret) <- c("summary.functionalGam", class(ret))
    return(ret)
}

#' Coef for functionalGam object
#'
#' @param object a fitted \code{functionalGam}-object
#' @param ... see \code{\link[refund]{coef.pffr}()} for options.
#'
#' @return coefficicents of the model, see \code{\link[refund]{coef.pffr}()}
#' @export
#' @method coef functionalGam
#' @author Martin Emons, adapted from \code{\link[refund]{coef.pffr}()} by Fabian Scheipl
coef.functionalGam <- function(object, ...){
    ret <- NextMethod("coef.pffr")
    # Rename (yindex) to (x) in names of smterms and pterms
    if (!is.null(names(ret$smterms))) {
        names(ret$smterms) <- gsub("yindex", "x", names(ret$smterms))
    }
    if (!is.null(names(ret$pterms))) {
        names(ret$pterms) <- gsub("yindex", "x", names(ret$pterms))
    }
    return(ret)
}

#' Functional Principal Component Analysis
#'
#' A function that takes as input the output of `calcMetricPerFov` which has to
#' be converted into the correct format by `prepData`. The output is a list with
#' the `fpca.face` output from refund.
#'
#' @param data a data object for functional data analysis containing at least
#' the functional response $Y$.
#' @param r the functional domain
#' @param ... Other parameters passed to `fpca.sc` functions
#'
#' @return a list with components of fpca.sc
#' @export
#'
#' @examples
#' # load the pancreas dataset
#' library("tidyr")
#' library("stringr")
#' library("dplyr")
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' # calculate the Gcross metric for alpha and Tc cells
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross",
#'     marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'     c("patient_stage", "patient_id", "image_number"), ncores = 1
#' )
#' metricRes$ID <- paste0(
#'   metricRes$patient_stage, "|", metricRes$patient_id,
#'   "|", metricRes$image_number
#' )
#' # prepare data for FDA
#' dat <- prepData(metricRes, "r", "rs")
#'
#' # drop rows with NA
#' dat <- dat |> drop_na()
#' # create meta info of the IDs
#' splitData <- str_split(dat$ID, "x")
#' dat$condition <- factor(sapply(splitData, function(x) x[1]))
#' dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
#' dat$image_id <- factor(sapply(splitData, function(x) x[3]))
#' # calculate fPCA
#' mdl <- functionalPCA(
#'     data = dat, r = metricRes$r |> unique()
#' )
#' @import dplyr
#' @importFrom methods is
functionalPCA <- function(data, r, ...) {
    stopifnot(is(data, "data.frame"))
    stopifnot(is(r, "vector"))
    # calculate the fPCA - this is a bit a pointless wrapper until now
    res <- refund::fpca.sc(
        Y = data$Y, center = TRUE, argvals = r, ...
    )
    return(res)
}

#' Plot a biplot from an fPCA analysis
#'
#' A function that takes the output from the `functionalPCA` function and
#' returns a `ggplot` object of the first two dimensions of the PCA as biplot.
#'
#' @param data a data object for functional data analysis containing at least
#' the functional response $Y$.
#' @param res the output from the fPCA calculation
#' @param colourby the variable by which to colour the PCA plot by
#' @param labelby the variable by which to label the PCA plot by
#'
#' @return a list with components of fpca.face
#' @export
#'
#' @examples
#' # load the pancreas dataset
#' library("tidyr")
#' library("stringr")
#' library("dplyr")
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' # calculate the Gcross metric for alpha and beta cells
#' metricRes <- calcMetricPerFov(spe, c("alpha", "beta"),
#'     subsetby = "image_number", fun = "Gcross",
#'     marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'     c("patient_stage", "patient_id", "image_number"), ncores = 1
#' )
#' metricRes$ID <- paste0(
#'   metricRes$patient_stage, "|", metricRes$patient_id,
#'   "|", metricRes$image_number
#' )
#'
#' # prepare data for FDA
#' dat <- prepData(metricRes, "r", "rs")
#'
#' # drop rows with NA
#' dat <- dat |> drop_na()
#' # create meta info of the IDs
#' splitData <- str_split(dat$ID, "|")
#' dat$condition <- factor(sapply(splitData, function(x) x[1]))
#' dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
#' dat$image_id <- factor(sapply(splitData, function(x) x[3]))
#' # calculate fPCA
#' mdl <- functionalPCA(
#'     data = dat, r = metricRes$r |> unique()
#' )
#' p <- plotFpca(
#'     data = dat, res = mdl, colourby = "condition",
#'     labelby = "patient_id"
#' )
#' print(p)
#' @import dplyr
#' @importFrom methods is
plotFpca <- function(data, res, colourby = NULL, labelby = NULL) {
    stopifnot(is(data, "data.frame"))
    stopifnot(is(res, "fpca"))
    scoresDf <- res$scores %>% as.data.frame()
    # plot fCPA results - assumes same order of fPCA results and input data
    p <- ggplot(scoresDf, aes(scoresDf[, 1], scoresDf[, 2],
        colour = factor(data[[colourby]])
    )) +
        geom_point() +
        coord_equal() +
        theme_light() +
        xlab("functional PC1") +
        ylab("functional PC2")
    if (!is.null(labelby)) {
        p <- p +
            geom_text(hjust = 0, vjust = 0,
                      aes(label = factor(data[[labelby]])))
    }
    return(p)
}

#' print the fPCA results
#'
#' this is a function that prints a summary of the fPCA result of class `fpca`
#'
#' @param x the result of function `functionalPCA`
#' @param ... other parameters passed to base generic function `print`
#'
#' @return a formatted overview of the fPCA result
#' @export
#'
#' @examples
#' # load the pancreas dataset
#' library("tidyr")
#' library("stringr")
#' library("dplyr")
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' # calculate the Gcross metric for alpha and beta cells
#' metricRes <- calcMetricPerFov(spe, c("alpha", "beta"),
#'     subsetby = "image_number", fun = "Gcross",
#'     marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'     c("patient_stage", "patient_id", "image_number"), ncores = 1
#' )
#' metricRes$ID <- paste0(
#'   metricRes$patient_stage, "|", metricRes$patient_id,
#'   "|", metricRes$image_number
#' )
#' # prepare data for FDA
#' dat <- prepData(metricRes, "r", "rs")
#'
#' # drop rows with NA
#' dat <- dat |> drop_na()
#'
#' # create meta info of the IDs
#' splitData <- strsplit(dat$ID, "|", fixed = TRUE)
#' dat$condition <- factor(sapply(splitData, function(x) x[1]))
#' dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
#' dat$image_id <- factor(sapply(splitData, function(x) x[3]))
#' # calculate fPCA
#' mdl <- functionalPCA(
#'     data = dat, r = metricRes$r |> unique()
#' )
#' mdl
print.fpca <- function(x, ...) {
    cat(paste0("Functional principal components analysis ",
                 "result from `fpca.sc` of `refund` \n"))
    cat(paste0("class: ", class(x), "\n"))
    cat(paste0("pve: ", round(x$pve, digits = 4), "\n"))
    cat(paste0("number of PCs: ", x$npc, "\n"))
    cat(paste0("eigenvalues:\n"))
    cat(x$evalues)
}

#' Compute a spatial metric on a SpatialExperiment object
#'
#' A function that takes a `SpatialExperiment` object and computes a spatial
#' statistics function as implemented in `spatstat`. The output is a `spatstat`
#' object.
#'
#' @param df A `dataframe` with the x and y coordinates from the corresponding
#' `SpatialExperiment` and the `colData`
#' @param selection the mark(s) you want to compare
#' @param fun the `spatstat` function to compute on the point pattern object
#' @param marks the marks to consider e.g. cell types
#' @param rSeq the range of r values to compute the function over
#' @param by the spe `colData` variable(s) to add to the meta data
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param window a observation window for the point pattern of class `owin`.
#' @param ... Other parameters passed to `spatstat.explore` functions
#'
#' @return a `spatstat` metric object with the fov number, the number of
#' points and the centroid of the image
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' speSub <- subset(spe, , image_number == "138")
#' dfSub <- .speToDf(speSub)
#' metricRes <- .extractMetric(dfSub, c("alpha", "Tc"),
#'     fun = "Gcross",
#'     marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
#'     by = c("patient_stage", "patient_id", "image_number")
#' )
#' @import spatstat.explore
#' @importFrom methods is
.extractMetric <- function(df,
    selection,
    fun,
    marks = NULL,
    rSeq = NULL,
    by = NULL,
    continuous = FALSE,
    window = NULL,
    ...) {
    # type checking
    stopifnot(is(df, "data.frame"))
    pp <- .dfToppp(df, marks = marks, continuous = continuous, window = window)
    stopifnot("Window size must be greater than the maximum radius length considered"
              =spatstat.geom::boundingradius(pp) >= max(rSeq))
    if (!continuous) {
        ppSub <- pp[pp$marks %in% selection, drop = TRUE]
        spatstat.geom::marks(ppSub) <- factor(spatstat.geom::marks(ppSub),
                                              levels = unique(selection))
        metaData <- df[, by] %>% base::unique() %>% as.data.frame()
        base::colnames(metaData) <- by
    } else {
        ppSub <- pp
        metaData <- df[, by] %>% base::unique() %>% as.data.frame()
        base::colnames(metaData) <- by
        metaData$gene <- base::names(df)[base::names(df) %in% marks]
    }
    # small quality control to only consider pp that have more than 2 points per
    # fov and more than one unique mark and that each mark has more than one point
    if (spatstat.geom::npoints(ppSub) > 2 &&
        ((length(unique(
            spatstat.geom::marks(ppSub)
        )) > 1 &&
            #small QC to only consider points with more than 1 points in general
            base::sum(base::table(ppSub$marks) > 1) > 1) ||
            base::length(selection) == 1)) {
        metricRes <- tryCatch(
            {
                metricRes <- do.call(fun,
                    args = list(X = ppSub, r = rSeq, ...)
                )
            },
            warning = function(w) {
                message(w)
                metricRes <- do.call(fun,
                    args = list(X = ppSub, r = rSeq, ...)
                )
            },
            error = function(e) {
                message(e)
                metricRes <- data.frame(
                  r = rSeq,
                  fun = fun,
                  row.names = seq_along(rSeq)
                )
            }
        )
    # This handles the case when we do cross functions for the same type
    } else if (spatstat.geom::npoints(ppSub) > 2 &&
        base::length(base::unique(selection)) == 1 &&
        base::length(selection) > 1) {
        metricRes <- tryCatch(
            {
                # here we use pp, otherwise there are problems with the
                # mark connection function
                metricRes <- do.call(fun, args = list(
                    X = pp,
                    i = selection[1],
                    j = selection[2],
                    r = rSeq,
                    ...
                ))
            },
            warning = function(w) {
                message(w)
                metricRes <- do.call(fun, args = list(
                    X = pp,
                    i = selection[1],
                    j = selection[2],
                    r = rSeq,
                    ...
                ))
            },
            error = function(e) {
                message(e)
                metricRes <- data.frame(
                  r = rSeq,
                  fun = fun,
                  row.names = seq_along(rSeq)
                )
            }
        )
    } else {
      # TODO: the row.names are off and do funny things - need to fix this still
        metricRes <- data.frame(
            r = rSeq,
            fun = fun,
            row.names = seq_along(rSeq)
        )
    }
    metricRes <- cbind(metricRes, metaData)

    #add the total number of points as weights
    metricRes$npoints <- spatstat.geom::npoints(ppSub)
    #has to be more than 1 point in order to find a nn
    if(unique(metricRes$npoints)>1){
      #add the minimum distance from one point to the nearest neighbour
      metricRes$minDist <- min(spatstat.geom::nndist(ppSub, k = 1))
    }
    #add the individual number of points of the marked pattern if multitype
    if(spatstat.geom::is.multitype(ppSub)){
      #first, split the point pattern
      ppSubSplit <- split(ppSub)
      if(length(ppSubSplit)>1){
        npoints1 <- spatstat.geom::npoints(ppSubSplit[[1]])
        npoints2 <- spatstat.geom::npoints(ppSubSplit[[2]])
        metricRes$npointsmin <- base::pmin(npoints1, npoints2)
        metricRes$npointsmax <- base::pmax(npoints1, npoints2)
      }#else if the pattern is multitype but only one point pattern is in it
      #min is the same as total and max
      else{
        metricRes$npointsmin <- metricRes$npoints
        metricRes$npointsmax <- metricRes$npoints
      }
    }# else if the pattern is not multitype, min is the same thing as max
    # and total
    else{
      metricRes$npointsmin <- metricRes$npoints
      metricRes$npointsmax <- metricRes$npoints
    }
    centroid <- spatstat.geom::centroid.owin(ppSub$window)
    metricRes$centroidx <- centroid$x
    metricRes$centroidy <- centroid$y
    metricRes$minIntensity <- base::min(spatstat.geom::intensity(ppSub))
    if(continuous == FALSE){
        metricRes$intensityQuery <- 
        spatstat.geom::intensity(ppSub)[[as.character(selection[length(selection)])]]
    }
    metricRes$pplevels <- paste(levels(spatstat.geom::marks(ppSub)),
                                collapse = " to ")
    # small assertion that the order of the levels in `ppSub`
    # correspond to the order indicated in `selection`
    if(!continuous){
      stopifnot(levels(spatstat.geom::marks(ppSub)) == selection)
    }
    rownames(metricRes) <- NULL
    return(metricRes)
}

#' Calculate a spatial metric on a `SpatialExperiment` object per field of view
#'
#' A function that takes a `SpatialExperiment` object as input and calculates a
#' spatial metric as implemented by `spatstat` per field of view.
#'
#' @param spe a `SpatialExperiment` object
#' @param selection the mark(s) you want to compare. NOTE: This is directional.
#' c(A,B) is not the same result as c(B,A).
#' @param subsetby the spe `colData` variable to subset the data by. This
#' variable has to be provided, even if there is only one sample.
#' @param fun the `spatstat` function to compute on the point pattern object
#' @param marks the marks to consider e.g. cell types
#' @param rSeq the range of r values to compute the function over
#' @param by the spe `colData` variable(s) to add to the meta data
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param assay the assay which is used if `continuous = TRUE`
#' @param verbose logical indicating whether to print all information or not
#' @param ncores the number of cores to use for parallel processing, default = 1
#' @param ... Other parameters passed to `spatstat.explore` functions
#'
#' @return a `dataframe` of the `spatstat` metric objects with the radius r, the
#' theoretical value of a Poisson process, the different border corrections
#' the fov number, the number of points and the centroid of the image
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#' @import dplyr parallel SpatialExperiment
#' @importFrom methods is
calcMetricPerFov <- function(spe, selection, subsetby, fun, marks = NULL,
    rSeq = NULL, by = NULL, continuous = FALSE, assay = "exprs", ncores = 1,
    verbose = TRUE, ...) {
    # type checking of input
    stopifnot(is(spe, "SpatialExperiment"))
    stopifnot(is(fun, "character"))
    stopifnot(is(marks, "character"))
    stopifnot(is(ncores, "numeric"))

    # check if the provide marks are in the column marks of spe colData
    if (!continuous && base::sum(!(selection %in% colData(spe)[[marks]])) > 0) {
      stop(paste0("not all marks of ", selection,
                  " are in the colData ", marks,  " of the spe"))
    }
    if(continuous) {
      expr <- SummarizedExperiment::assay(spe, assay)[marks, , drop=FALSE] %>%
        as.matrix() %>%
        t() %>%
        data.frame()
      colnames(expr) <- marks

      colData(spe) <- colData(spe) %>% cbind(expr)
    }
    df <- .speToDf(spe)
    if(length(selection)>1){
      # printing the combination calculated
        if(verbose){
            message(paste0("Calculating ", fun, " from ",
                            selection[1], " to ",
                            selection[2]))
        }
    }
    else{
      # printing the combination calculated
        if(verbose){
            message(paste0("Calculating ", fun, " of ", selection[1]))
        }
    }
    # we have one case for discrete cell types where we have one column to subset
    if (length(subsetby) == 1) {
        dfLs <- base::split(df, df[[subsetby]])
    } else {
        dfLs <- purrr::map(subsetby, ~ df %>%
            dplyr::select(dplyr::all_of(
              dplyr::setdiff(base::names(df), subsetby)), .x))
    }
    metricDf <- parallel::mclapply(dfLs, function(dfSub) {
        metricRes <- .extractMetric(
            df = dfSub,
            selection = selection,
            fun = fun,
            marks = marks,
            rSeq = rSeq,
            by = by,
            continuous = continuous,
            ...
        ) %>% as.data.frame()
        return(metricRes)
    }, mc.cores = ncores) %>% dplyr::bind_rows()
    # store metadata of the calculation in the dataframe
    metricDf$fun <- fun
    metricDf$selection <- paste(selection, collapse = " to ")
    return(metricDf)
}


#' Calculate cross spatial metrics for all combinations per FOV
#'
#' A function that takes a `SpatialExperiment` object as input and calculates a
#' cross spatial metric as implemented by `spatstat` per field of view for all
#' combinations provided by the user.
#'
#' @param spe a `SpatialExperiment` object
#' @param selection the mark(s) you want to compare
#' @param subsetby the spe `colData` variable to subset the data by
#' @param fun the `spatstat` function to compute on the point pattern object
#' @param marks the marks to consider e.g. cell types
#' @param rSeq the range of r values to compute the function over
#' @param by the spe `colData` variable(s) to add to the meta data
#' @param ncores the number of cores to use for parallel processing, default = 1
#' @param continuous A boolean indicating whether the marks are continuous
#' defaults to FALSE
#' @param assay the assay which is used if `continuous = TRUE`
#' @param ... Other parameters passed to spatstat.explore functions
#'
#' @return a dataframe of the `spatstat` metric objects with the radius r, the
#' theoretical value of a Poisson process, the different border corrections
#' the fov number, the number of points and the centroid of the image
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcCrossMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#'
#' @importFrom methods is
calcCrossMetricPerFov <- function(
        spe, selection, subsetby = NULL, fun,
        marks = NULL, rSeq = NULL, by = NULL,
        ncores = 1, continuous = FALSE, assay = "exprs", ...) {
    # type checking of input
    stopifnot(is(spe, "SpatialExperiment"))
    stopifnot(is(fun, "character"))
    stopifnot(is(marks, "character"))
    stopifnot(is(ncores, "numeric"))

    # Special case of dot functions
    if (grepl("dot", fun)) {
        # one vs all other
        ls <- unique(selection)
        # calculate the metric per FOV
        resLs <- lapply(ls, function(x) {
            message(x)
            calcMetricPerFov(
                spe = spe, selection = x, subsetby = subsetby, fun = fun,
                marks = marks, rSeq = rSeq, by = by, ncores = ncores,
                continuous = continuous, assay, ...
            )
        })
        # Bind the data and return
        return(dplyr::bind_rows(resLs))
    } else {
        # This creates a grid with all possible 2 way combinations
        ls <- apply(base::expand.grid(selection, selection), 1, function(x) {
            return(c(x[1], x[2]))
        }) %>% t()

        # calculate the metric per FOV
        resLs <- apply(ls, 1, function(x) {
            calcMetricPerFov(
                spe = spe, selection = x, subsetby = subsetby, fun = fun,
                marks = marks, rSeq = rSeq, by = by, ncores = ncores,
                continuous = continuous, ...
            )
        })

        # Bind the data and return
        return(dplyr::bind_rows(resLs))
    }
}

# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
rSeq <- seq(0, 50, length.out = 50)

## test function calcMetricPerFov
test_that("Output contains correction for discrete single mark", {
  rSeq <- seq(0, 50, length.out = 50)
  metricRes <- calcMetricPerFov(spe, "alpha",
                                subsetby = "image_number", fun = "Gest",
                                marks = "cell_type",
                                rSeq = rSeq, by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"),
                                correction = "rs",
                                ncores = 1
  )
  expect_contains(colnames(metricRes), "rs")
  expect_contains(colnames(metricRes), "r")
  expect_contains(colnames(metricRes), "theo")
})

test_that("Output contains correction for continuous single mark", {
  # add continuous mark to colData
  protein <- "CD31"

  rSeq <- seq(0, 50, length.out = 50)
  metricRes <- calcMetricPerFov(spe, "alpha",
                                subsetby = "image_number", fun = "markcorr",
                                marks = protein,
                                rSeq = rSeq, by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"),
                                correction = "iso",
                                ncores = 1,
                                continuous = TRUE
  )
  expect_contains(colnames(metricRes), "iso")
  expect_contains(colnames(metricRes), "r")
  expect_contains(colnames(metricRes), "theo")
})

test_that("Output contains correction for two marks", {
  metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
                                subsetby = "image_number", fun = "Gcross",
                                marks = "cell_type",
                                rSeq = rSeq, by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"),
                                correction = "rs",
                                ncores = 1
  )
  expect_contains(colnames(metricRes), "rs")
  expect_contains(colnames(metricRes), "r")
  expect_contains(colnames(metricRes), "theo")
})

test_that("Output has correct dimensions", {
  metricRes <- calcMetricPerFov(spe, "alpha",
                                subsetby = "image_number", fun = "Gest",
                                marks = "cell_type",
                                rSeq = rSeq, by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"),
                                correction = "rs",
                                ncores = 1
  )
  expect_length(metricRes$rs, length(rSeq) * length(unique(spe$image_name)))
})

test_that("Function fails if marks not in ColData", {
  expect_error(calcMetricPerFov(spe, c("alpha", "epsilon"),
                                subsetby = "image_number", fun = "Gcross",
                                marks = "cell_type",
                                rSeq = rSeq, by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"
                                ),
                                ncores = 1
  ))
})

test_that("Function fails if max rSeq is greater than Window", {
  spe_alphabeta <- subset(spe, ,cell_type %in% c("alpha","beta"))
  expect_error(calcMetricPerFov(spe_alphabeta, c("alpha", "beta"),
                                subsetby = "image_number", fun = "Gcross",
                                marks = "cell_type",
                                rSeq =  seq(0, 200, length.out = 50), by = c(
                                  "patient_stage", "patient_id",
                                  "image_number"
                                ),
                                ncores = 1
  ))
})

# Test function calcCrossMetricPerFov
test_that("Cross function output has correct dimensions", {
  selection <- c("alpha", "beta", "delta")
  metricRes <- calcCrossMetricPerFov(spe, selection,
                                     subsetby = "image_number", fun = "Gcross",
                                     marks = "cell_type",
                                     rSeq = seq(0, 50, length.out = 50), by = c(
                                       "patient_stage", "patient_id",
                                       "image_number"
                                     ),
                                     ncores = 1
  )

  expect_length(metricRes$rs,
                (length(rSeq) * length(unique(spe$image_name))
                * (length(selection)^2)))
})

test_that("Cross function output has correct dimensions for Kdot", {
  selection <- c("alpha", "beta", "delta")
  metricRes <- calcCrossMetricPerFov(spe, selection,
                                     subsetby = "image_number", fun = "Kdot",
                                     marks = "cell_type",
                                     rSeq = seq(0, 50, length.out = 50), by = c(
                                       "patient_stage", "patient_id",
                                       "image_number"
                                     ),
                                     correction = "border",
                                     ncores = 1
  )

  expect_length(metricRes$border,
                length(rSeq) * (length(unique(spe$image_name)))
                * (length(selection)))
})

test_that("Numeric results are correct for Lcross image 148", {
  selection <- c("alpha", "Tc")
  speSub <- subset(spe, , image_number == "148")
   dfSub <- .speToDf(speSub)
   metricRes <- .extractMetric(dfSub, selection,
       fun = "Lcross",
       marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
       by = c("patient_stage", "patient_id", "image_number")
   ) %>% as.data.frame()
  resObserved <- metricRes %>% dplyr::select(dplyr::all_of(c("r", "theo", "border", "trans", "iso"))) %>%
    dplyr::slice(1,4,19,38,45,50)
  resExpected <- read.csv('lcross_single.csv')

  expect_equal(object = resObserved[complete.cases(resObserved), ],
               expected = resExpected[complete.cases(resExpected), ])
})

test_that("Numeric results are correct for Lcross", {
  selection <- c("alpha", "Tc")
  metricRes <- calcMetricPerFov(spe = spe,
                                selection = selection,
                                subsetby = "image_number",
                                fun = "Lcross",
                                marks = "cell_type",
                                rSeq = seq(0, 50, length.out = 50),
                                by = c("patient_stage", "patient_id",
                                     "image_number"),
                                ncores = 1)
  resObserved <- metricRes %>% dplyr::select(dplyr::all_of(c("r", "theo", "border", "trans", "iso"))) %>%
    dplyr::slice(5,29,432,1100,3872,4983)
  resExpected <- read.csv('lcross.csv')

  expect_equal(object = resObserved[complete.cases(resObserved), ],
               expected = resExpected[complete.cases(resExpected), ])
})

test_that("Numeric results are correct for Gcross", {
  selection <- c("alpha", "Tc")
  metricRes <- calcMetricPerFov(spe = spe,
                                selection,
                                subsetby = "image_number",
                                fun = "Gcross",
                                marks = "cell_type",
                                rSeq = seq(0, 50, length.out = 50),
                                by = c("patient_stage", "patient_id",
                                       "image_number"),
                                ncores = 1)
  resObserved <- metricRes %>% dplyr::select(dplyr::all_of(c("r", "theo", "han", "rs", "km"))) %>%
    dplyr::slice(5,29,432,1100,3872,4983)
  resExpected <- read.csv('gcross.csv')

  expect_equal(object = resObserved[complete.cases(resObserved), ],
               expected = resExpected[complete.cases(resExpected), ])
})

test_that("Min Points + Max Points = Total Points", {
  selection <- c("alpha", "Tc")
  metricRes <- calcMetricPerFov(spe = spe,
                                selection,
                                subsetby = "image_number",
                                fun = "Gcross",
                                marks = "cell_type",
                                rSeq = seq(0, 50, length.out = 50),
                                by = c("patient_stage", "patient_id",
                                       "image_number"),
                                ncores = 1)
  minPoints <- metricRes$npointsmin
  maxPoints <- metricRes$npointsmax
  totalPoints <- metricRes$npoints

  expect_equal(object = minPoints + maxPoints,
               expected = totalPoints)
})

test_that("spatstat.geom::nndist has a working check if only 1 point is available",{
  selection <- "beta"
  metricRes <- calcMetricPerFov(spe = spe,
                                selection,
                                subsetby = "image_number",
                                fun = "Gest",
                                marks = "cell_type",
                                rSeq = seq(0, 50, length.out = 50),
                                by = c("patient_stage", "patient_id",
                                       "image_number"),
                                ncores = 1)

  metricResSub <- metricRes %>% subset(patient_id == 6180)

  expect_true(sum(is.na(metricResSub$minDist))==nrow(metricResSub))
})

#' Prepare data from calcMetricRes to be in the right format for FDA
#'
#' @param metricRes a dataframe as calculated by calcMetricRes - requires
#' the columns ID (unique identifier of each row)
#' @param x the name of the x-axis of the spatial metric
#' @param y the name of the y-axis of the spatial metric
#' @param sample_id the spe `colData` variable to mark the sample
#' @param image_id the spe `colData` variable to mark the image
#' @param condition the spe `colData` variable to mark the condition
#' @param ID the unique ID corresponding to each row in the metricRes defaults
#' to `"ID"`
#'
#' @return returns a list with three entries, the unique ID, the functional
#' response Y and the weights
#' @export
#'
#' @examples
#' # retrieve example data from Damond et al. (2019)
#' spe <- .loadExample()
#' metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
#'     subsetby = "image_number", fun = "Gcross", marks = "cell_type",
#'     rSeq = seq(0, 50, length.out = 50), by = c(
#'         "patient_stage", "patient_id",
#'         "image_number"
#'     ),
#'     ncores = 1
#' )
#'
#' # create a unique ID for each row
#' metricRes$ID <- paste0(
#'     metricRes$patient_stage, "|", metricRes$patient_id,
#'     "|", metricRes$image_number
#' )
#' dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
#' image_id = "image_number", condition = "patient_stage")
#' @import tidyr
#' @importFrom methods is
prepData <- function(metricRes, x, y, sample_id = NULL, image_id = NULL,
                     condition = NULL, ID = "ID"){
    # type checking
    stopifnot(is(metricRes, "data.frame"))
    stopifnot(is(x, "character"))
    stopifnot(is(y, "character"))
    # extract the functional response matrix
    mat <- metricRes %>%
        dplyr::select(ID, x, y) %>%
        tidyr::spread(ID, y) %>%
        dplyr::select(!x) %>%
        as.matrix() 


    storage.mode(mat) <- "numeric"
    # create a dataframe as required by pffr
    # the colnames of the matrix are the new row IDs
    dat <- data.frame(ID = colnames(mat))
    # transpose of the matrix to have the entire response in one row
    dat$Y <- t(mat)
    # extract the number of points as weights
    weights <- metricRes %>%
      dplyr::select("ID", "npoints", "npointsmin", "npointsmax") %>%
      unique()
    # add the weights to the data.frame
    dat <- dat %>% dplyr::left_join(weights, by = "ID")
    # extract the coordinates and meta data and convert to factor
    meta <- metricRes %>%
        dplyr::select("ID", "centroidx", "centroidy", "minIntensity", sample_id,
                      image_id, condition, "intensityQuery") %>%
        unique() %>%
        mutate(across(c(sample_id,
                        image_id, condition), as.factor))
    # add the coordinates to the data.frame
    dat <- dat %>% dplyr::left_join(meta, by = "ID")

    return(dat)
}

---
title: "Functional Data Analysis of Spatial Metrics"
author: 
  - name: "Martin Emons"
    affiliation:
      - &DMLS Department of Molecular Life Sciences, University of Zurich, Switzerland
      - &SIB SIB Swiss Institute of Bioinformatics, Lausanne, Switzerland
    email: "martin.emons@uzh.ch"
  - name: Fabian Scheipl
    affiliation:
      - &LMU Department of Statistics, Ludwig-Maximilians-Universität München, Germany
  - name: Mark D. Robinson
    affiliation:
      - *DMLS
      - *SIB
package: "`r BiocStyle::Biocpkg('spatialFDA')`"
output:
  BiocStyle::html_document
abstract: >
  This vignette shows how to perform a custom spatial analysis with the package `spatialFDA`. 
vignette: >
  %\VignetteIndexEntry{Functional Data Analysis of Spatial Metrics}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
bibliography: spatialFDA.bib
editor_options: 
  chunk_output_type: console
---

```{r v1, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    eval = TRUE
)
```

# Introduction

This vignette demonstrates how to use `r BiocStyle::Biocpkg('spatialFDA')` to perform functional data analysis on spatial statistics metrics. The main aim of this package is to detect differential spatial arrangements within and between cell types given several samples/conditions. It does so by calculating spatial statistics metrics via the `r BiocStyle::CRANpkg('spatstat')` package and comparing differences using functional additive mixed models as implemented in the `r BiocStyle::CRANpkg('refund')` package [@spatstat2005; @refund2024].

The use case is a dataset from @damondMapHumanType2019 which contains images from 12 human donors. The raw data is published under a `CC-BY-4.0` License on [Mendeley](https://data.mendeley.com/datasets/cydmwsfztj/2). 

This package is similar to other packages in `python` and `R`. The following table shows the main differences in terms of functionality [@ali2024graphcompass; @canete2022spicyr; @wrobel2024mxfda]. 

|Package name                          | Foundation | Testing procedure   |
| ------------------------------------ | --------------- | ------------------- |
| `r BiocStyle::Biocpkg('spicyR')`     | $L$-function    | Scalar comparison   |
| `GraphCompass`                       | Graph-based     | Graph and  scalar comparison | 
| `r BiocStyle::CRANpkg('mxfda')`      | $K$-, $G$- and $L$- function | Function as input for survival modelling |
| `r BiocStyle::Biocpkg('spatialFDA')` | most `r BiocStyle::CRANpkg('spatstat')` functions   | Functional comparison over domain |

# Installation

`r BiocStyle::Biocpkg('spatialFDA')` can be installed and loaded from Bioconductor as follows

```{r installation, include = TRUE, eval = FALSE}
if (!requireNamespace("BiocManager")) {
    install.packages("BiocManager")
}
BiocManager::install("spatialFDA")
```

```{r setup, warning = FALSE, message = FALSE}
library("spatialFDA")
library("dplyr")
library("ggplot2")
library("tidyr")
library("stringr")
library("dplyr")
library("patchwork")
library("SpatialExperiment")

set.seed(1234)
```

# Getting started

In this vignette we will analyse a diabetes dataset acquired by imaging mass cytometry (IMC) as acquired by @damondMapHumanType2019. The dataset contains images from 12 human donors, 4 healthy and 8 with type 1 diabetes (T1D). With IMC, 35 markers were measured at single cell resolution [@damondMapHumanType2019].

## Loading the data

The @damondMapHumanType2019 dataset is easily loaded from `ExperimentHub` via a small reader function `.loadExample()`. The entire dataset can be loaded by setting `full = TRUE`. For computational reasons, one can reduce to three patients as well by setting this flag to `FALSE`. We will subset the entire dataset to two samples per condition in order to have a multi-condition/multi-sample setting. The package offers multiple datatypes, we will use the `r BiocStyle::Biocpkg('SpatialExperiment')` (SPE) object [@righelli2022spatialexperiment].

```{r loading, warning = FALSE, message = FALSE}
# retrieve example data from Damond et al. (2019)
spe <- .loadExample(full = TRUE)

spe <- subset(spe, ,patient_id %in% c(6089,6180,6126,6134,6228,6414))
# set cell types as factors
colData(spe)$cell_type <- as.factor(colData(spe)$cell_type) 
```

## Visualising the raw data

We can look at the fields of view (FOVs) of the diabetes dataset. To do so we extract the spatial coordinates, store them as a dataframe and add the colData from the SPE to this. We will look only at the first four FOVs of the healthy sample. We plot both the cell categories of all cells and then the cell types of secretory cells ($\alpha, \beta$ and $\delta$ cells) and T-cells (CD8+ and CD4+ T-cells).

```{r plotting fovs, warning = FALSE, fig.width=8, fig.height=15}
df <- data.frame(spatialCoords(spe), colData(spe))

dfSub <- df %>%
    subset(image_name %in% c("E02", "E03", "E04", "E05"))

p <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_category)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell category")+
    coord_equal() +
    theme_light()

dfSub <- dfSub %>%
    subset(cell_type %in% c("alpha", "beta", "delta", "Th", "Tc"))

q <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_type)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell type") +
    coord_equal() +
    theme_light()
wrap_plots(list(p,q), widths = c(1,1), heights = c(1,1), nrow = 2, ncol = 1)
```

# Calculating Spatial Statistics Metrics

In a first step, we calculate a spatial statistic curve as implemented by `r BiocStyle::CRANpkg('spatstat')`. One can choose from a range of metrics for discrete marks and calculate these within a mark or between two marks. Common metrics are:

- Ripley's $K$ function and its variance stabilised form, Besag's $L$

- Pair correlation function $g$

- Nearest-neighbour function $G$

- Empty space function $F$

Note that all of these functions have different implementations to correct for inhomogeneity and for comparison between two marks (cross functions) [@baddeleySpatialPointPatterns].

All spatial statistics metrics are a function of radius $r$. As such, we have to determine the maximum radius sequence to consider. [@baddeleySpatialPointPatterns] recommend to take a maximum radius $r$ that is not larger than $1/4$ of the window length. As the window can be non-convex, we calculate the half of the minimum bounding radius of the observation window as heuristic.

```{r}
p <- rMaxHeuristic(spe,
subsetby = "image_number", marks = "cell_type"
)
p
```

We will consider a rMax of $50$ for analysing shorter-range interactions.

## Correlation

With correlation metrics, we assess the *distances* of all points to one another while normalising for density effects and of the window size $|W|$. Furthermore, spatial metrics are corrected for edge effects, due to the fact that points at the border of a FOV do not have a fully-observed neighborhood [@baddeleySpatialPointPatterns, pp. 203 ff.].  

A well-known metric is Ripley's $K$ function or its variance-stabilised transformation, the $L$ function. We can calculate a variant of the $L$ function with the function `calcMetricPerFov` between e.g $\alpha$ and cytotoxic T cells. The output is a dataframe with the following most important columns:

- `r`: the radius at which the spatial metric is evaluated

- `theo`: the theoretical value of a homogeneous (Poisson) realisation of a point process

- `iso`: an isotropic edge corrected value of the $L$ function


```{r Lfunction, warning = FALSE, message = FALSE}
metricRes <- calcMetricPerFov(spe = spe, selection = c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Lcross", 
                              marks = "cell_type",
                              rSeq = seq(0, 50, length.out = 50), 
                              by = c("patient_stage", "patient_id",
                                     "image_number"),
                              ncores = 1)
metricRes %>% head(3)
```

We can visualise this metric with `plotMetricPerFov` function. Here, we need to specify which border correction we want to plot and what the $x$-axis is. Both can vary from function to function.

```{r plotLfunction, warning = FALSE, fig.width=8, fig.height=8}
# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "iso", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)
```

By eye, we see no visible difference between the conditions in terms of correlation 
of $\alpha$ and cytotoxic T cells.

## Spacing

Another important aspect of spatial analysis is spacing. Here, the shortest distances or empty space to the next neighbor is calculated. This quantifies a different aspect of a point pattern than correlation or intensity of points. Two well-known functions are [@baddeleySpatialPointPatterns, pp. 255-266]:

- nearest-neighbor distance distribution $G$

- empty space function $F$

For spacing metrics, we get different border corrections but otherwise the output stays the same:

```{r Gfunction, warning = FALSE, message = FALSE}
metricRes <- calcMetricPerFov(spe = spe, selection = c("alpha", "Tc"),
                              subsetby = "image_number", fun = "Gcross", 
                              marks = "cell_type",
                              rSeq = seq(0, 50, length.out = 50), 
                              by = c("patient_stage", "patient_id",
                                     "image_number"),
                              ncores = 1)
metricRes %>% head(3)
```

```{r plotGfunction, warning = FALSE, fig.width=8, fig.height=8}
# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "rs", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)
```

In the nearest-neighbor distance function, we see a strong difference between onset T1D, long-duration T1D and non-diabetic controls in terms of spacing of $\alpha$ and cytotoxic T cells. 

# Functional boxplot

Looking at raw spatial statistics curves can be challenging. In order to summarise this information, we can plot functional boxplots by aggregating the curves into boxplots via a user-defined variable `aggregate_by`. We use the `fbplot` function from the `r BiocStyle::CRANpkg('fda')` package [@sun2011functional; @ramsay2024fda].

```{r, funcBoxPlot, warning = FALSE, results='hide'}
# create a unique ID per row in the dataframe
metricRes$ID <- paste0(
    metricRes$patient_stage, "x", metricRes$patient_id,
    "x", metricRes$image_number
)
#removing field of views that have as a curve only zeros - these are cases where
#there is no cells of one type
metricRes <- metricRes %>% dplyr::group_by(ID) %>% dplyr::filter(sum(rs) >= 1)

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")
```

The functional boxplot shows that onset $G$-curves are more variable than the corresponding long-duration and non-diabetic curves. We note as well, that the variability is heteroscedastic along the domain (i.e., variance increases with radius), which is undesirable for our statistical modelling. Therefore, we can e.g. apply a variance stabilising transformation to our data or model this variance in the statistical model.

```{r, variancetransform, warning = FALSE}
# can determine with a boxcox transformation what is the ideal parameter
# for the transformation use Fisher's variance-stabilising transformation
metricRes$rs <- asin(sqrt(metricRes$rs))

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")
```

# Functional principal component analysis

Another analysis that can be performed is functional principal componentent analysis (fPCA). This is a method to capture the main modes of variation in functional data [@ramsayPrincipalComponentsAnalysis2005]. We use the `r BiocStyle::CRANpkg('refund')` implementation of fPCA. 

```{r fPCA, warning = FALSE}
# filter out all rows that have a constant zero part - all r=<10
metricRes <- metricRes %>% filter(r >= 10)

# prepare dataframe from calcMetricRes to be in the correct format for pffr
dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
 image_id = "image_number", condition = "patient_stage")

dat$condition <- gsub("-","_", dat$patient_stage) %>% 
  as.factor() %>%
  relevel("Non_diabetic")

# drop rows with NA
dat <- dat |> drop_na()
# calculate the fPCA
pca <- functionalPCA(dat = dat, r = metricRes$r |> unique(), pve = 0.995)
evalues <- pca$evalues
efunctions <- pca$efunctions
# plot the mean curve and the two first eigenfunctions
p_mu <- ggplot(data.frame(r = unique(metricRes$r), mu = pca$mu), 
               aes(x = r, y = mu)) +
    geom_line() +
    theme_light() +
    xlab("r [µm]")

p_efunction1 <- ggplot(data.frame(r = unique(metricRes$r), 
                                  phi1 = pca$efunctions[,1]), 
                       aes(x = r, y = phi1)) +
    geom_line() +
    theme_light() +
    ylim(-0.3,0.3) +
    xlab("r [µm]")

p_efunction2 <- ggplot(data.frame(r = unique(metricRes$r),
                                  phi2 = pca$efunctions[,2]),
                       aes(x = r, y = phi2)) +
    geom_line() +
    theme_light() +
    ylim(-0.3,0.3) +
    xlab("r [µm]")

wrap_plots(list(p_mu, p_efunction1, p_efunction2), ncol = 3)
# plot the biplot of the first two PCs
plotFpca(dat = dat, res = pca, colourby = "condition")
# print the eigenvalues
evalues
```

In the biplot above we get a very basic differentiation of the $G$ curves. Onset T1D shows most variability along the first fPC. The second fPC describes less variation. 

# Functional additive mixed models

The $L$ function above showed no clear difference between the three conditions whereas the $G$ function showed a strong difference between onset T1D and the two other conditions. In order to test these differences we will use generalised functional additive mixed models. These are generalisations of standard additive mixed models to compare functions over their entire domain. The package that we use is the `r BiocStyle::CRANpkg('refund')` package [@scheiplFunctionalAdditiveMixed2015; @scheiplGeneralizedFunctionalAdditive2016; @refund2024].

The model implemented here is of the form:

$$
\mathbb{E}[y_i(r)] = g^{-1}(\alpha(r) + \beta_{0,g(i)}(r) + \sum_{j=1}^J f_j(X_{ji},r))
$$

With the following terms:

- $y_i(r)$: functional response, here the `r BiocStyle::CRANpkg('spatstat')` curves

- $g$: optional link function 

- $\alpha(r)$: global functional intercept varying over the domain $r$

- $\beta_{0,g(i)}(r)$: random functional intercept varying over the domain $r$ per grouping variable $g(i)$.

- $f_j(X_{ji},r)$: additive predictors

For the family we will use a scaled $t$-distribution with a logarithmic link function. This distribution has a positive support, thereby modelling the strictly positive response of the spatial statistics functions. 

In this context we need to specify a design matrix and contrasts. For the functional random intercepts we define a smooth function for each patient ID as implemented in `refund` [@refund2024].

```{r funcGamG, fig.height=10, warning = FALSE}
library('refund')
# create a design matrix
mm <- model.matrix(~condition, data = dat)
mm %>% head()

r <- metricRes$r |> unique()
# fit the model
mdl <- functionalGam(
    data = dat, x = r,
    designmat = mm, weights = dat$npoints,
    formula = formula(Y ~ 1 + conditionLong_duration +
                          conditionOnset + s(patient_id, bs = "re")),
    family = mgcv::scat(link = "log"),
    algorithm = "bam"
)
summary(mdl)

plotLs <- lapply(colnames(mm), plotMdl, mdl = mdl,
                 shift = mdl$coefficients[["(Intercept)"]])
wrap_plots(plotLs, nrow = 3, axes = 'collect')
```


We note that there is a small non-significant difference in the $G$ function between non-diabetic and long-duration T1D samples, but a strong difference between non-diabetic and onset T1D according to the model summary. The point wise confidence bands are a limitation of this method and could be improved with either bootstrapping or continuous confidence bands [@liebl2023fast]. Thus, we see not only that a spatial difference in co-localisation of $\alpha$ and cytotoxic T cells is statistically significant but also at which spatial scale this difference occurs.

## Model evaluation

One open problem is the implementation of confidence bands that reflect the non-independently and non-identically distributed residuals. To visualise how much of a problem this is, we can plot the contours of the correlation/covariance and look at model diagnostics.

```{r contour, warning = FALSE}
resid(mdl) |> cor() |> filled.contour(levels = seq(-1, 1, l = 40))
resid(mdl) |> cov() |> filled.contour()

qqnorm(resid(mdl), pch = 16)
qqline(resid(mdl))
```

In these model diagnostics, we note that there is still some variability in the residuals that is not considered by the model. The Q-Q plot indicates a good but not perfect model fit. The residuals show a considerable structure that is in line with the structure in the auto-covariance / correlation plots.

In the functional additive mixed model, we have specified global intercept varying over the domain $r$ as well as functional random intercepts varying over the domain $r$ per grouping variable `patient_id`. We can plot these smooth estimates of the random intercepts.

```{r intercept, warning = FALSE, eval = TRUE}
# look at the smooth random intercepts per patient
data <- coef(mdl)$smterms$`character(0)`$coef

data <- data %>% left_join(dat %>% 
                             select(patient_id, condition) %>% unique)

p <- ggplot(data, aes(x = yindex.vec, y = value, colour = condition, group = patient_id)) +
  geom_line() +
  theme_light() + 
  geom_smooth(aes(group = 1), col = 'black') +
  xlab("r [µm]")

p
```

We note that these random errors are not constrained to sum-to-zero over the domain $r$. This can lead to problems of identifiability between the global intercept and the functional random intercepts. 

```{r sessionInfo}
sessionInfo()
```

---
title: "Overview Functional Data Analysis of Spatial Metrics"
author: 
  - name: "Martin Emons"
    affiliation:
      - &DMLS Department of Molecular Life Sciences, University of Zurich, Switzerland
      - &SIB SIB Swiss Institute of Bioinformatics, Lausanne, Switzerland
    email: "martin.emons@uzh.ch"
  - name: Fabian Scheipl
    affiliation:
      - &LMU Department of Statistics, Ludwig-Maximilians-Universität München, Germany
  - name: Mark D. Robinson
    affiliation:
      - *DMLS
      - *SIB
package: "`r BiocStyle::Biocpkg('spatialFDA')`"
output:
  BiocStyle::html_document
abstract: >
  `spatialFDA` is a package to calculate spatial statistics metrics and compare them with   methods from functional data analysis. Here, we show how to perform a standard spatial analysis  using `spatialFDA`.
vignette: >
  %\VignetteIndexEntry{Overview Functional Data Analysis of Spatial Metrics}
  %\VignetteEncoding{UTF-8}  
  %\VignetteEngine{knitr::rmarkdown}
bibliography: spatialFDA.bib
editor_options: 
  chunk_output_type: console
---

```{r v1, include = FALSE}
knitr::opts_chunk$set(
    collapse = TRUE,
    comment = "#>",
    eval = TRUE
)
```

# Introduction

This vignette serves as an overview how to use `r BiocStyle::Biocpkg('spatialFDA')` to perform functional data analysis on spatial statistics metrics. The main aim of this package is to detect differential spatial arrangements between cells in multi-sample/condition experiments. It combines the the estimation with the `r BiocStyle::CRANpkg('spatstat')` package with the inference of `r BiocStyle::CRANpkg('refund')` [@spatstat2005; @baddeleySpatialPointPatterns; @refund2024].

This vignette is a brief overview version of the "Detailed Functional Data Analysis of Spatial Metrics" vignette. The content and code is in parts overlapping.

The use case is a dataset from @damondMapHumanType2019 which contains images from 12 human donors. The raw data is published under a `CC-BY-4.0` License on [Mendeley](https://data.mendeley.com/datasets/cydmwsfztj/2). 

# Installation

`r BiocStyle::Biocpkg('spatialFDA')` can be installed and loaded from Bioconductor as follows

```{r installation, include = TRUE, eval = FALSE}
if (!requireNamespace("BiocManager")) {
    install.packages("BiocManager")
}
BiocManager::install("spatialFDA")
```

```{r setup, warning = FALSE, message = FALSE}
library("spatialFDA")
library("dplyr")
library("ggplot2")
library("tidyr")
library("stringr")
library("dplyr")
library("patchwork")
library("SpatialExperiment")

set.seed(1234)
```

# Getting started

In this vignette we will analyse a diabetes dataset acquired by imaging mass cytometry (IMC) as acquired by @damondMapHumanType2019. The dataset contains images from 12 human donors, 4 healthy and 8 with type 1 diabetes (T1D). With IMC, 35 markers were measured at single cell resolution [@damondMapHumanType2019].

## Loading the data

The @damondMapHumanType2019 dataset is easily loaded from `ExperimentHub` via a small reader function `.loadExample()`. The entire dataset can be loaded by setting `full = TRUE`. For computational reasons, one can reduce to three patients as well by setting this flag to `FALSE`. We will subset the entire dataset to two samples per condition in order to have a multi-condition/multi-sample setting. The package offers multiple datatypes, we will use the `r BiocStyle::Biocpkg('SpatialExperiment')` (SPE) object [@righelli2022spatialexperiment].

```{r loading, warning = FALSE, message = FALSE}
# retrieve example data from Damond et al. (2019)
spe <- .loadExample(full = TRUE)

spe <- subset(spe, ,patient_id %in% c(6089,6180,6126,6134,6228,6414))
# set cell types as factors
colData(spe)$cell_type <- as.factor(colData(spe)$cell_type) 
```

## Visualising the raw data

We can look at the fields of view (FOVs) of the diabetes dataset. To do so we extract the spatial coordinates, store them as a dataframe and add the colData from the SPE to this. We will look only at the first four FOVs of the healthy sample. We plot both the cell categories of all cells and then the cell types of secretory cells ($\alpha, \beta$ and $\delta$ cells) and T-cells (CD8+ and CD4+ T-cells).

```{r plotting fovs, warning = FALSE, fig.width=8, fig.height=15}
df <- data.frame(spatialCoords(spe), colData(spe))

dfSub <- df %>%
    subset(image_name %in% c("E02", "E03", "E04", "E05"))

p <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_category)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell category")+
    coord_equal() +
    theme_light()

dfSub <- dfSub %>%
    subset(cell_type %in% c("alpha", "beta", "delta", "Th", "Tc"))

q <- ggplot(dfSub, aes(x = cell_x, y = cell_y, color = cell_type)) +
    geom_point(size= 0.5) +
    facet_wrap(~image_name) +
    theme(legend.title.size = 20, legend.text.size = 20) +
    xlab("x") +
    ylab("y") +
    labs(color = "cell type") +
    coord_equal() +
    theme_light()
wrap_plots(list(p,q), widths = c(1,1), heights = c(1,1), nrow = 2, ncol = 1)
```

# Spatial Inference

`r BiocStyle::Biocpkg('spatialFDA')` consists of two main steps, the calculation of the spatial statistics function per individual image and the comparison of these functions via functional data analysis (FDA). `r BiocStyle::Biocpkg('spatialFDA')` contains the convenience function `spatialInference` which streamlines the estimation explained in the "Detailed Functional Data Analysis of Spatial Metrics" vignette.

The first important step is to consider the sequences of radii to calculate the spatial statistics function over. [@baddeleySpatialPointPatterns] recommend to take never a radius larger than $1/4$ of the window length. We have implemented a heuristic of this measure as half of the minimum bounding radius over all images. The histogram indicates the variability in the bounding radii.

```{r}
p <- rMaxHeuristic(spe,
subsetby = "image_number", marks = "cell_type"
)
p
```

From the plot we see that a maximum radius of $50$ is justified across all images.

In order to perform the spatial inference, we have to pass the `r BiocStyle::Biocpkg('SpatialExperiment')` object, the cell types we want to analyse (`selection`), how we want to subset the data (`subsetby`), the spatial statistic function to compute (`fun`), which columns are the marks/cell types (`marks`), the radius domain to compute on (`rSeq`) and the edge correction to perform (`correction`).

Furthermore, for the functional data analysis part we can provide the sample_id if there are replicates (`sample_id`, will lead to a mixed effects model), the transformation to apply to the output of the spatial statistics metric (here, we apply a square root transformation to stabilise the variance), the image ID (`image_id`) as well as the conditions (`conditions`)

```{r, crossSpatialInference, results='hide', message = FALSE, warning = FALSE}
#relevel to have non-diabetic as the reference category
spe$patient_stage <- relevel(factor(spe$patient_stage), "Non-diabetic")

#run the spatial statistics inference
resLs <- crossSpatialInference(
    spe, 
    selection = c("alpha", "Tc"),
    fun = "Gcross", 
    marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), 
    correction = "rs",
    sample_id = "patient_id",
    image_id = "image_number", 
    condition = "patient_stage",
    intensityAdjustment = TRUE
)

names(resLs)
```

We first consider the combination of cell types defined in `selection` as an overview bubble plot of the $F$-test results. This gives us a general indication of which cell types are co-localising and a notion of significance of the $F$-test.

```{r, bubblePlot, results='hide', message = FALSE, eval=TRUE}
p <- plotCrossHeatmap(resLs, coefficientsToPlot = c("conditionLong_duration(x)", "conditionOnset(x)"), QCThreshold = 0, QCMetric = "medianMinIntensity")
p <- p + theme(legend.position = "bottom") + guides(shape = "none") + 
  facet_wrap(~factor(coefficient, levels = c("conditionOnset(x)", "conditionLong_duration(x)"), labels = c("conditionOnset(x)" = "Onset", "conditionLong_duration(x)" = "Long-Duration")))

p
```

We notice that there is a strong co-localisation of cytoxic T-cells with pancreatic alpha cells in onset diabetes. We will consider the interaction of alpha cells and cytoxic T-cells in more detail.

```{r, resSelection, eval=TRUE}
res <- resLs$alpha_Tc
names(res)
```

The output is a list of four objects: The dataframe with the calculated spatial statistics curves from `r BiocStyle::CRANpkg('spatstat')`, the design matrix for the statistical inference, the output of the `pffr` function from `r BiocStyle::CRANpkg('refund')`, as well as the residual standard error per condition [@baddeleySpatialPointPatterns; @spatstat2005; @refund2024; @scheiplFunctionalAdditiveMixed2015].

## Spatial Statistics Curves

We can visualise the spatial statistics curves per image with the function `plotMetricPerFov`. Note that these curves are variance-stabilised, since we added a transformation parameter above. 

```{r, plotFunction, message = FALSE, warning = FALSE,}
#filtered and stabilised curves
metricRes <- res$metricRes

# create a unique plotting ID
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id
)
# change levels for plotting
metricRes$ID <- factor(metricRes$ID, levels = c("Non-diabetic|6126",
                                                "Non-diabetic|6134",
                                                "Onset|6228","Onset|6414",
                                                "Long-duration|6089",
                                                "Long-duration|6180"))
# plot metrics
plotMetricPerFov(metricRes, correction = "rs", x = "r",
                 imageId = "image_number", ID = "ID", ncol = 2)
``` 

We note that there is pronounced variability between the three conditions, between the patients as well as between individual images.

## Functional Boxplot

In order to summarise the variability of the curves calculated above, we can use the 
functional boxplot. The functional boxplot is a generalisation of a standard boxplot, giving information about the median curve (black solid line), the 50% central region (area coloured in magenta), the minimum and maximum envelopes (blue solid lines) and outlier curves (red dashed lines). Here, the `fbplot` function from the `r BiocStyle::CRANpkg('fda')` package is used [@sun2011functional; @ramsay2024fda].

```{r funcBoxPlot, warning = FALSE, results='hide'}
# create a unique ID per row in the dataframe
metricRes$ID <- paste0(
    metricRes$patient_stage, "x", metricRes$patient_id,
    "x", metricRes$image_number
)

collector <- plotFbPlot(metricRes, "r", "rs", "patient_stage", "patient_id",  "image_number")
```

The functional boxplot provides a convenient summary of the spatial statistics curves. We see that the median curve for onset samples plateaus at a higher level and that non-diabetic and long-duration functional boxplots are in general very similar. There are some outlier curves but since they are not far off the envelopes, we do not filter them out. In comparison to the raw spatial statistics curves we note that the transformations stabilise the variance along the domain $r$

## Functional GAMM

In the functional boxplot we got an overview of the variability of the spatial statistic curves and could describe differences qualitatively. In order to test these differences, we use inference via functional data analysis. The functional general additive mixed model (fGAMM) provides a way to perform statistical inference on the spatial statistics functions and is implemented in the function `pffr` from `r BiocStyle::CRANpkg('refund')` [@scheiplFunctionalAdditiveMixed2015; @scheiplGeneralizedFunctionalAdditive2016; @refund2024]. 

```{r, funcGamm}
mdl <- res$mdl
mm <- res$designmat

summary(mdl, re.test = FALSE)
```

The summary of the fGAMM provides information on the constant parameters and the functional coefficients. For the functional coefficients, an $F$-test over the entire domain is performed which answers the question if there is any difference between the reference curves (here "Non-diabetic") and the conditions over the entire domain. 

We note that there is a small non-significant difference in the $G$ function between non-diabetic and long-duration T1D samples, but a strong difference between non-diabetic and onset T1D according to the model summary. 

As the functional coefficients are functions of the domain $r$ themselves, we can plot them too

```{r, plotFuncGamm}
plotLs <- lapply(colnames(mm), plotMdl, mdl = mdl,
                 shift = mdl$coefficients[["(Intercept)"]])
wrap_plots(plotLs, nrow = 3, axes = 'collect')
```

From the functional coefficients we see that the difference betwenn Non-diabetic and Onset diabetic curves is at short distances and that the difference becomes less pronounced at higher distances. This means that the differential co-localisation between cytotoxic T-cells and alpha cells in the islet happens at shorter distances.

The point wise confidence bands are a limitation of this method and could be improved with either bootstrapping or continuous confidence bands [@liebl2023fast].

## Model evaluation

The functional GAMMs provide coefficients that we could plot above. In order to judge the confidence we can have in these coefficients, we look to quantify the model fit. First, we look at the correlation and check the qq plot of the model residuals.

```{r contour, warning = FALSE}
residuals(mdl) |> cor() |> filled.contour(levels = seq(-1, 1, l = 40))
residuals(mdl) |> cov() |> filled.contour()

qqnorm(mdl$residuals, pch = 16)
qqline(mdl$residuals)
```

In these model diagnostics, we note that there is still some variability in the residuals that is not considered by the model. The Q-Q plot indicates a good but not perfect model fit. The residuals show a considerable structure that is in line with the structure in the auto-covariance / correlation plots.

```{r sessionInfo}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calcMetric.R
\name{.extractMetric}
\alias{.extractMetric}
\title{Compute a spatial metric on a SpatialExperiment object}
\usage{
.extractMetric(
  df,
  selection,
  fun,
  marks = NULL,
  rSeq = NULL,
  by = NULL,
  continuous = FALSE,
  window = NULL,
  ...
)
}
\arguments{
\item{df}{A \code{dataframe} with the x and y coordinates from the corresponding
\code{SpatialExperiment} and the \code{colData}}

\item{selection}{the mark(s) you want to compare}

\item{fun}{the \code{spatstat} function to compute on the point pattern object}

\item{marks}{the marks to consider e.g. cell types}

\item{rSeq}{the range of r values to compute the function over}

\item{by}{the spe \code{colData} variable(s) to add to the meta data}

\item{continuous}{A boolean indicating whether the marks are continuous
defaults to FALSE}

\item{window}{a observation window for the point pattern of class \code{owin}.}

\item{...}{Other parameters passed to \code{spatstat.explore} functions}
}
\value{
a \code{spatstat} metric object with the fov number, the number of
points and the centroid of the image
}
\description{
A function that takes a \code{SpatialExperiment} object and computes a spatial
statistics function as implemented in \code{spatstat}. The output is a \code{spatstat}
object.
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
speSub <- subset(spe, , image_number == "138")
dfSub <- .speToDf(speSub)
metricRes <- .extractMetric(dfSub, c("alpha", "Tc"),
    fun = "Gcross",
    marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
    by = c("patient_stage", "patient_id", "image_number")
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcPca.R
\name{functionalPCA}
\alias{functionalPCA}
\title{Functional Principal Component Analysis}
\usage{
functionalPCA(data, r, ...)
}
\arguments{
\item{data}{a data object for functional data analysis containing at least
the functional response $Y$.}

\item{r}{the functional domain}

\item{...}{Other parameters passed to \code{fpca.sc} functions}
}
\value{
a list with components of fpca.sc
}
\description{
A function that takes as input the output of \code{calcMetricPerFov} which has to
be converted into the correct format by \code{prepData}. The output is a list with
the \code{fpca.face} output from refund.
}
\examples{
# load the pancreas dataset
library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and Tc cells
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross",
    marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
    c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "|", metricRes$patient_id,
  "|", metricRes$image_number
)
# prepare data for FDA
dat <- prepData(metricRes, "r", "rs")

# drop rows with NA
dat <- dat |> drop_na()
# create meta info of the IDs
splitData <- str_split(dat$ID, "x")
dat$condition <- factor(sapply(splitData, function(x) x[1]))
dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
dat$image_id <- factor(sapply(splitData, function(x) x[3]))
# calculate fPCA
mdl <- functionalPCA(
    data = dat, r = metricRes$r |> unique()
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMdl.R
\name{plotMdl}
\alias{plotMdl}
\title{Plot a pffr model object}
\usage{
plotMdl(mdl, predictor, shift = NULL)
}
\arguments{
\item{mdl}{a \code{pffr} model object}

\item{predictor}{predictor to plot}

\item{shift}{the value by which to shift the centered functional intercept.
this will most often be the constant intercept}
}
\value{
ggplot object of the functional estimate
}
\description{
A function that takes a pffr object as calculated in \code{functionalGam} and
plots the functional coefficients. The functions are centered such that their
expected value is zero. Therefore, the scalar intercept has to be added to
the output with the argument \code{shift} in order to plot the coefficients in
their original range.
}
\examples{
library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), by = c(
        "patient_stage", "patient_id",
        "image_number"
    ),
    ncores = 1
)
# create a unique ID for each row
metricRes$ID <- paste0(
    metricRes$patient_stage, "x", metricRes$patient_id,
    "x", metricRes$image_number
)

dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
    image_id = "image_number", condition = "patient_stage")

#' # drop rows with NA
dat <- dat |> drop_na()

# create a designmatrix
condition <- dat$patient_stage
# relevel the condition - can set explicit contrasts here
condition <- relevel(condition, "Non-diabetic")
designmat <- model.matrix(~condition)
# colnames don't work with the '-' sign
colnames(designmat) <- c(
    "(Intercept)", "conditionLong_duration",
    "conditionOnset"
)
# fit the model
mdl <- functionalGam(
    data = dat, x = metricRes$r |> unique(),
    designmat = designmat, weights = dat$npoints,
    formula = formula(Y ~ conditionLong_duration +
        conditionOnset + s(patient_id, bs = "re")),
        algorithm = "bam"
)
summary(mdl, re.test = FALSE)
plotLs <- lapply(colnames(designmat), plotMdl,
    mdl = mdl,
    shift = mdl$coefficients[["(Intercept)"]]
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/crossSpatialInference.R
\name{crossSpatialInference}
\alias{crossSpatialInference}
\title{Function for Cross Spatial Inference}
\usage{
crossSpatialInference(
  spe,
  selection = NULL,
  fun,
  marks = NULL,
  rSeq = NULL,
  correction,
  sample_id,
  image_id,
  condition,
  continuous = FALSE,
  assay = "exprs",
  transformation = NULL,
  eps = 0.001,
  delta = "minNnDist",
  family = stats::gaussian(link = "log"),
  verbose = TRUE,
  ncores = 1,
  ...
)
}
\arguments{
\item{spe}{a \code{SpatialExperiment} object}

\item{selection}{the mark(s) you want to compare. NOTE: This is directional.
c(A,B) is not the same result as c(B,A).}

\item{fun}{the \code{spatstat} function to compute on the point pattern object}

\item{marks}{the marks to consider e.g. cell types}

\item{rSeq}{the range of r values to compute the function over}

\item{correction}{the edge correction to be applied}

\item{sample_id}{the spe \code{colData} variable to mark the sample, if not NULL
this will result in a mixed model estimation}

\item{image_id}{the spe \code{colData} variable to mark the image}

\item{condition}{the spe \code{colData} variable to mark the condition}

\item{continuous}{A boolean indicating whether the marks are continuous
defaults to FALSE}

\item{assay}{the assay which is used if \code{continuous = TRUE}}

\item{transformation}{the transformation to be applied as exponential e.g. 1/2 for sqrt}

\item{eps}{some distributional families fail if the response is zero,
therefore, zeros can be replaced with a very small value eps}

\item{delta}{the delta value to remove from the beginning of the spatial
statistics functions. Can be reasonable if e.g. cells are always spaced
by 10 µm. If set to "minNnDist" it will take the mean of the minimum nearest
neighbour distance across all images for this cell type pair.}

\item{family}{the distributional family for the functional GAM}

\item{verbose}{logical indicating whether to print all information or not}

\item{ncores}{the number of cores to use for parallel processing, default = 1}

\item{...}{Other parameters passed to \code{spatstat.explore} functions for
parameters concerning the spatial function calculation and to \code{refund::pffr}
for the functional additive mixed model inference}
}
\value{
a list of objects created by the function \code{spatialInference}
with three objects: i) the dataframe with the spatial
statistics results, ii) the designmatrix of the inference and iii) the
fitted pffr object
}
\description{
This function is a wrappere function around \code{spatialInference}. It calculates
\code{spatialInference} results either for all cell types in \code{marks}
(if \code{selection == NULL}) or for a custom subset defined in \code{selection}.
}
\examples{
spe <- .loadExample()
#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
"Non-diabetic")

selection <- c("acinar", "ductal")
resLs <- crossSpatialInference(spe, selection, fun = "Gcross",
                      marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
                      correction = "rs", sample_id = "patient_id",
                      image_id = "image_number", condition = "patient_stage",
                      algorithm = "bam",
                      ncores = 1
                  )

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcPca.R
\name{print.fpca}
\alias{print.fpca}
\title{print the fPCA results}
\usage{
\method{print}{fpca}(x, ...)
}
\arguments{
\item{x}{the result of function \code{functionalPCA}}

\item{...}{other parameters passed to base generic function \code{print}}
}
\value{
a formatted overview of the fPCA result
}
\description{
this is a function that prints a summary of the fPCA result of class \code{fpca}
}
\examples{
# load the pancreas dataset
library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and beta cells
metricRes <- calcMetricPerFov(spe, c("alpha", "beta"),
    subsetby = "image_number", fun = "Gcross",
    marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
    c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "|", metricRes$patient_id,
  "|", metricRes$image_number
)
# prepare data for FDA
dat <- prepData(metricRes, "r", "rs")

# drop rows with NA
dat <- dat |> drop_na()

# create meta info of the IDs
splitData <- strsplit(dat$ID, "|", fixed = TRUE)
dat$condition <- factor(sapply(splitData, function(x) x[1]))
dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
dat$image_id <- factor(sapply(splitData, function(x) x[3]))
# calculate fPCA
mdl <- functionalPCA(
    data = dat, r = metricRes$r |> unique()
)
mdl
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.dfToppp}
\alias{.dfToppp}
\title{Convert SpatialExperiment object to ppp object}
\usage{
.dfToppp(df, marks = NULL, continuous = FALSE, window = NULL)
}
\arguments{
\item{df}{A dataframe with the x and y coordinates from the corresponding
SpatialExperiment and the ColData}

\item{marks}{A vector of marks to be associated with the points, has to be
either named 'cell_type' if you want to compare discrete celltypes or else
continous gene expression measurements are assumed as marks.}

\item{continuous}{A boolean indicating whether the marks are continuous
defaults to FALSE}

\item{window}{An observation window of the point pattern of class \code{owin}.}
}
\value{
A ppp object for use with \code{spatstat} functions
}
\description{
Convert SpatialExperiment object to ppp object
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
speSub <- subset(spe, , image_number == "138")
dfSub <- .speToDf(speSub)
pp <- .dfToppp(dfSub, marks = "cell_type")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMetric.R
\name{plotFbPlot}
\alias{plotFbPlot}
\title{Functional boxplot of spatstat curves}
\usage{
plotFbPlot(metricDf, x, y, aggregateBy, sampleId, imageId)
}
\arguments{
\item{metricDf}{the metric dataframe as calculated by \code{calcMetricPerFov}}

\item{x}{the name of the x-axis of the spatial metric}

\item{y}{the name of the y-axis of the spatial metric}

\item{aggregateBy}{the criterion by which to aggregate the curves into a
functional boxplot. Can be e.g. the condition of the different samples.}

\item{sampleId}{the ID of the sample}

\item{imageId}{the ID of the image/fov}
}
\value{
a list of base R plots
}
\description{
This function creates a functional boxplot of the spatial statistics curves.
It creates one functional boxplot per aggregation category, e.g. condition.
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), by = c(
        "patient_stage", "patient_id",
        "image_number"
    ),
    ncores = 1
)
# create a unique ID for the data preparation
metricRes$ID <- paste0(
  metricRes$patient_stage, "|", metricRes$patient_id,
  "|", metricRes$image_number
)

plotFbPlot(metricRes, 'r', 'rs', 'patient_stage', 'patient_id',
 'image_number')
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/prepData.R
\name{prepData}
\alias{prepData}
\title{Prepare data from calcMetricRes to be in the right format for FDA}
\usage{
prepData(
  metricRes,
  x,
  y,
  sample_id = NULL,
  image_id = NULL,
  condition = NULL,
  ID = "ID"
)
}
\arguments{
\item{metricRes}{a dataframe as calculated by calcMetricRes - requires
the columns ID (unique identifier of each row)}

\item{x}{the name of the x-axis of the spatial metric}

\item{y}{the name of the y-axis of the spatial metric}

\item{sample_id}{the spe \code{colData} variable to mark the sample}

\item{image_id}{the spe \code{colData} variable to mark the image}

\item{condition}{the spe \code{colData} variable to mark the condition}

\item{ID}{the unique ID corresponding to each row in the metricRes defaults
to \code{"ID"}}
}
\value{
returns a list with three entries, the unique ID, the functional
response Y and the weights
}
\description{
Prepare data from calcMetricRes to be in the right format for FDA
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), by = c(
        "patient_stage", "patient_id",
        "image_number"
    ),
    ncores = 1
)

# create a unique ID for each row
metricRes$ID <- paste0(
    metricRes$patient_stage, "|", metricRes$patient_id,
    "|", metricRes$image_number
)
dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
image_id = "image_number", condition = "patient_stage")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcPca.R
\name{plotFpca}
\alias{plotFpca}
\title{Plot a biplot from an fPCA analysis}
\usage{
plotFpca(data, res, colourby = NULL, labelby = NULL)
}
\arguments{
\item{data}{a data object for functional data analysis containing at least
the functional response $Y$.}

\item{res}{the output from the fPCA calculation}

\item{colourby}{the variable by which to colour the PCA plot by}

\item{labelby}{the variable by which to label the PCA plot by}
}
\value{
a list with components of fpca.face
}
\description{
A function that takes the output from the \code{functionalPCA} function and
returns a \code{ggplot} object of the first two dimensions of the PCA as biplot.
}
\examples{
# load the pancreas dataset
library("tidyr")
library("stringr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and beta cells
metricRes <- calcMetricPerFov(spe, c("alpha", "beta"),
    subsetby = "image_number", fun = "Gcross",
    marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
    c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "|", metricRes$patient_id,
  "|", metricRes$image_number
)

# prepare data for FDA
dat <- prepData(metricRes, "r", "rs")

# drop rows with NA
dat <- dat |> drop_na()
# create meta info of the IDs
splitData <- str_split(dat$ID, "|")
dat$condition <- factor(sapply(splitData, function(x) x[1]))
dat$patient_id <- factor(sapply(splitData, function(x) x[2]))
dat$image_id <- factor(sapply(splitData, function(x) x[3]))
# calculate fPCA
mdl <- functionalPCA(
    data = dat, r = metricRes$r |> unique()
)
p <- plotFpca(
    data = dat, res = mdl, colourby = "condition",
    labelby = "patient_id"
)
print(p)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/calcMetric.R
\name{calcMetricPerFov}
\alias{calcMetricPerFov}
\title{Calculate a spatial metric on a \code{SpatialExperiment} object per field of view}
\usage{
calcMetricPerFov(
  spe,
  selection,
  subsetby,
  fun,
  marks = NULL,
  rSeq = NULL,
  by = NULL,
  continuous = FALSE,
  assay = "exprs",
  ncores = 1,
  verbose = TRUE,
  ...
)
}
\arguments{
\item{spe}{a \code{SpatialExperiment} object}

\item{selection}{the mark(s) you want to compare. NOTE: This is directional.
c(A,B) is not the same result as c(B,A).}

\item{subsetby}{the spe \code{colData} variable to subset the data by. This
variable has to be provided, even if there is only one sample.}

\item{fun}{the \code{spatstat} function to compute on the point pattern object}

\item{marks}{the marks to consider e.g. cell types}

\item{rSeq}{the range of r values to compute the function over}

\item{by}{the spe \code{colData} variable(s) to add to the meta data}

\item{continuous}{A boolean indicating whether the marks are continuous
defaults to FALSE}

\item{assay}{the assay which is used if \code{continuous = TRUE}}

\item{ncores}{the number of cores to use for parallel processing, default = 1}

\item{verbose}{logical indicating whether to print all information or not}

\item{...}{Other parameters passed to \code{spatstat.explore} functions}
}
\value{
a \code{dataframe} of the \code{spatstat} metric objects with the radius r, the
theoretical value of a Poisson process, the different border corrections
the fov number, the number of points and the centroid of the image
}
\description{
A function that takes a \code{SpatialExperiment} object as input and calculates a
spatial metric as implemented by \code{spatstat} per field of view.
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), by = c(
        "patient_stage", "patient_id",
        "image_number"
    ),
    ncores = 1
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCrossHeatmap.R
\name{extractCrossInferenceData}
\alias{extractCrossInferenceData}
\title{Reshaping the Result of a Cross Spatial Inference to a Dataframe}
\usage{
extractCrossInferenceData(
  resLs,
  QCMetric = "medianMinIntensity",
  QCThreshold = 0.1
)
}
\arguments{
\item{resLs}{a list with four objects: i) the dataframe with the spatial
statistics results transformed and filtered as used for fitting,
ii) the raw spatial statistics results, iii) the designmatrix of the
inference and iv) the fitted pffr object v) the residual standard error per
condition defined as the residual sum of squares divided by the number of
datapoints - sum of the estimated degrees of freedom for the model parameters
as well as other QC metrics}

\item{QCMetric}{the metric to relate the quality of the fit too.}

\item{QCThreshold}{the threshold on the QC metric. Depends
on the function used.}
}
\value{
a dataframe for plotting with ggplot2
}
\description{
Reshaping the Result of a Cross Spatial Inference to a Dataframe
}
\examples{
spe <- .loadExample()
#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
"Non-diabetic")

selection <- c("acinar", "ductal")
resLs <- crossSpatialInference(spe, selection,
                      fun = "Gcross", marks = "cell_type",
                      rSeq = seq(0, 50, length.out = 50), correction = "rs",
                      sample_id = "patient_id",
                      image_id = "image_number", condition = "patient_stage",
                      algorithm = "bam",
                      ncores = 1
                  )
df <- extractCrossInferenceData(resLs)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.loadExample}
\alias{.loadExample}
\title{load Example dataset from Damond et al. (2019)}
\usage{
.loadExample(full = FALSE)
}
\arguments{
\item{full}{a boolean indicating whether to load the entire
Damond et al. (2019) or only a subset}
}
\value{
A SpatialExperiment object as uploaded to \code{ExperimentHub()}
}
\description{
load Example dataset from Damond et al. (2019)
}
\examples{
# retrieve the Damond et al. (2019) dataset
spe <- .loadExample()

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotCrossHeatmap.R
\name{plotCrossHeatmap}
\alias{plotCrossHeatmap}
\title{Plotting the Result of a Cross Spatial Inference}
\usage{
plotCrossHeatmap(
  resLs,
  adj.pvalue = "BH",
  coefficientsToPlot = NULL,
  QCThreshold = 1e-05,
  QCMetric = "medianMinIntensity",
  ...
)
}
\arguments{
\item{resLs}{a list with four objects: i) the dataframe with the spatial
statistics results transformed and filtered as used for fitting,
ii) the raw spatial statistics results, iii) the designmatrix of the
inference and iv) the fitted pffr object v) the residual standard error per
condition defined as the residual sum of squares divided by the number of
datapoints - sum of the estimated degrees of freedom for the model parameters
as well as other QC metrics}

\item{adj.pvalue}{a pvalue adjustment method as passed to stats::p.adjust
defaults to Benjamini-Hochberg correction of the false discovery rate.}

\item{coefficientsToPlot}{list of which coefficients to plot in the heatmap
defaults to NULL in which case all coefficients are plotted}

\item{QCThreshold}{the threshold on the Quality control metric. Depends
on the function used.}

\item{QCMetric}{the metric to relate the quality of the fit too.}

\item{...}{other parameters passed to \code{ggplot2} functions}
}
\value{
a ggplot2 object
}
\description{
Plotting the Result of a Cross Spatial Inference
}
\examples{
spe <- .loadExample()
#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
"Non-diabetic")

selection <- c("acinar", "ductal")
resLs <- crossSpatialInference(spe, selection,
                      fun = "Gcross", marks = "cell_type",
                      rSeq = seq(0, 50, length.out = 50), correction = "rs",
                      sample_id = "patient_id",
                      image_id = "image_number", condition = "patient_stage",
                      algorithm = "bam",
                      ncores = 1
                  )
p <- plotCrossHeatmap(resLs, adj.pvalue = "BH")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/utils.R
\name{.speToDf}
\alias{.speToDf}
\title{Transform a SpatialExperiment into a dataframe}
\usage{
.speToDf(spe)
}
\arguments{
\item{spe}{A SpatialExperiment object subset to a single image}
}
\value{
A dataframe with the x and y coordinates from the corresponding
SpatialExperiment and the colData
}
\description{
Transform a SpatialExperiment into a dataframe
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
speSub <- subset(spe, , image_number == "138")
dfSub <- .speToDf(speSub)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMetric.R
\name{plotCrossFOV}
\alias{plotCrossFOV}
\title{Creates a nXn plot of the cross metrics per sample}
\usage{
plotCrossFOV(
  subFov,
  theo,
  correction,
  x,
  imageId,
  ID = NULL,
  ncol = NULL,
  nrow = NULL,
  legend.position = "none",
  ...
)
}
\arguments{
\item{subFov}{a subset of the \code{dataframe} to the respective fov}

\item{theo}{logical; if the theoretical line should be plotted}

\item{correction}{the border correction to plot}

\item{x}{the x-axis variable to plot}

\item{imageId}{the ID of the image/fov}

\item{ID}{the (optional) ID for plotting combinations}

\item{ncol}{the number of columns for the facet wrap}

\item{nrow}{the number of rows for the facet wrap}

\item{legend.position}{the position of the legend of the plot}

\item{...}{Other parameters passed to \code{ggplot2} functions}
}
\value{
a ggplot object
}
\description{
Helper function for \code{plotCrossMetricPerFov}. It applies \code{plotMetricPerFov}
to all \code{n} marks defined in the variable \code{selection}. This gives an
\code{nxn} plot of all marks.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rMaxHeuristic.R
\name{rMaxHeuristic}
\alias{rMaxHeuristic}
\title{Heuristic for the choice of rMax}
\usage{
rMaxHeuristic(spe, subsetby, marks)
}
\arguments{
\item{spe}{a \code{SpatialExperiment} object}

\item{subsetby}{the spe \code{colData} variable to subset the data by. This
variable has to be provided, even if there is only one sample.}

\item{marks}{the marks to consider e.g. cell types}
}
\value{
a ggplot histogram of the bounding radius of all the
}
\description{
Heuristic for the choice of rMax
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
p <- rMaxHeuristic(spe,
subsetby = "image_number", marks = "cell_type"
)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcGam.R
\name{summary.functionalGam}
\alias{summary.functionalGam}
\title{Summary for functionalGam object}
\usage{
\method{summary}{functionalGam}(object, ...)
}
\arguments{
\item{object}{a fitted \code{functionalGam}-object}

\item{...}{see \code{\link[mgcv]{summary.gam}()} for options.}
}
\value{
A list with summary information, see \code{\link[mgcv]{summary.gam}()}
}
\description{
Summary for functionalGam object
}
\author{
Martin Emons, adapted from \code{\link[refund]{summary.pffr}()} by Fabian Scheipl
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plotMetric.R
\name{plotMetricPerFov}
\alias{plotMetricPerFov}
\title{Plot a spatial metric per field of view}
\usage{
plotMetricPerFov(
  metricDf,
  theo = FALSE,
  correction = NULL,
  x = NULL,
  imageId = NULL,
  ID = NULL,
  nrow = NULL,
  ncol = NULL,
  legend.position = "none",
  ...
)
}
\arguments{
\item{metricDf}{the metric \code{dataframe} as calculated by \code{calcMetricPerFov}}

\item{theo}{logical; if the theoretical line should be plotted}

\item{correction}{the border correction to plot}

\item{x}{the x-axis variable to plot}

\item{imageId}{the ID of the image/fov}

\item{ID}{the (optional) ID for plotting combinations}

\item{nrow}{the number of rows for the facet wrap}

\item{ncol}{the number of columns for the facet wrap}

\item{legend.position}{the position of the legend of the plot}

\item{...}{Other parameters passed to \code{ggplot2} functions}
}
\value{
a \code{ggplot} object
}
\description{
A function that plots the output of the function \code{calcMetricPerFov}. The plot
contains one curve per FOV and makes subplots by samples.
}
\examples{
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), by = c(
        "patient_stage", "patient_id",
        "image_number"
    ),
    ncores = 1
)
# ceate a unique plotting ID
metricRes$ID <- paste0(
 metricRes$patient_stage, "|", metricRes$patient_id
)

p <- plotMetricPerFov(metricRes,
    correction = "rs", x = "r",
    imageId = "image_number", ID = "ID"
)
print(p)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/funcGam.R
\name{functionalGam}
\alias{functionalGam}
\title{General additive model with functional response}
\usage{
functionalGam(
  data,
  x,
  designmat,
  weights,
  formula,
  family = stats::gaussian(link = "log"),
  algorithm = "bam",
  bs.yindex = list(bs = "ps", k = 5, m = c(2, 1)),
  bs.int = list(bs = "ps", k = 20, m = c(2, 1)),
  sandwich = "cluster",
  discrete = TRUE,
  ...
)
}
\arguments{
\item{data}{a dataframe with the following columns: Y = functional response;
sample_id = sample ID; image_id = image ID;}

\item{x}{the x-axis values of the functional response}

\item{designmat}{a design matrix as defined by model.matrix()}

\item{weights}{weights as the number of points per image. These weights are
normalised by the mean of the weights in the fitting process}

\item{formula}{the formula for the model. The colnames of the designmatrix
have to correspond to the variables in the formula.}

\item{family}{the distributional family as implemented in \code{family.mgcv}. For
fast computation the default is set to \code{gaussian} with a log link.
other interesting options can be \code{betar} and \code{scat}
\itemize{
\item for more information see \code{family.mgcv}.
}}

\item{algorithm}{algorithm to fit the refund::pffr method. defaults to \code{bam}}

\item{bs.yindex}{a list specifying the spline bases for the index. See \code{refund::pffr}
for more details}

\item{bs.int}{a list specfying the spline bases for the global function intercept.
See \code{refund::pffr} for more details}

\item{sandwich}{string indicating how and if to adjust for heterscedasticity of the
residuals with a sandwich correction}

\item{discrete}{option to discretise the function for faster computation. default is
\code{TRUE}. See \code{mgcv::bam} for more information. When using \code{gam}, this option has to be
\code{FALSE}}

\item{...}{Other parameters passed to \code{pffr}}
}
\value{
a fitted pffr object which inherits from gam
}
\description{
A function that takes the output of a metric calculation as done by
\code{calcMetricPerFov}. The data has to be prepared into the correct format for
the functional analysis by the \code{prepData} function. The output is a \code{pffr}
object as implemented by \code{refund}.
}
\examples{
# load the pancreas dataset
library("tidyr")
library("dplyr")
# retrieve example data from Damond et al. (2019)
spe <- .loadExample()
# calculate the Gcross metric for alpha and Tc cells
metricRes <- calcMetricPerFov(spe, c("alpha", "Tc"),
    subsetby = "image_number", fun = "Gcross",
    marks = "cell_type", rSeq = seq(0, 50, length.out = 50),
    c("patient_stage", "patient_id", "image_number"), ncores = 1
)
metricRes$ID <- paste0(
  metricRes$patient_stage, "|", metricRes$patient_id,
  "|", metricRes$image_number
)
dat <- prepData(metricRes, "r", "rs", sample_id = "patient_id",
    image_id = "image_number", condition = "patient_stage")

#' # drop rows with NA
dat <- dat |> drop_na()

# create a designmatrix
condition <- dat$patient_stage
# relevel the condition - can set explicit contrasts here
condition <- relevel(condition, "Non-diabetic")
designmat <- model.matrix(~condition)
# colnames don't work with the '-' sign
colnames(designmat) <- c(
    "(Intercept)", "conditionLong_duration",
    "conditionOnset"
)
# fit the model
mdl <- functionalGam(
    data = dat, x = metricRes$r |> unique(),
    designmat = designmat, weights = dat$npoints,
    formula = formula(Y ~ conditionLong_duration +
        conditionOnset + s(patient_id, bs = "re")),
        algorithm = "bam"
)
summary(mdl)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/spatialInference.R
\name{spatialInference}
\alias{spatialInference}
\title{Statistical Inference on Spatial Statistics Functions}
\usage{
spatialInference(
  spe,
  selection,
  fun,
  marks = NULL,
  rSeq = NULL,
  correction,
  sample_id,
  image_id,
  condition,
  continuous = FALSE,
  assay = "exprs",
  transformation = NULL,
  intensityAdjustment = "default",
  weights = "total",
  eps = 0.001,
  delta = "minNnDist",
  family = stats::gaussian(link = "log"),
  verbose = TRUE,
  upperDeltaProb = NULL,
  weightTransform = TRUE,
  AR1 = FALSE,
  sandwich = "cluster",
  ncores = 1,
  algorithm = "bam",
  ...
)
}
\arguments{
\item{spe}{a \code{SpatialExperiment} object}

\item{selection}{the mark(s) you want to compare. NOTE: This is directional.
c(A,B) is not the same result as c(B,A).}

\item{fun}{the \code{spatstat} function to compute on the point pattern object}

\item{marks}{the marks to consider e.g. cell types}

\item{rSeq}{the range of r values to compute the function over}

\item{correction}{the edge correction to be applied}

\item{sample_id}{the spe \code{colData} variable to mark the sample, if not NULL
this will result in a mixed model estimation}

\item{image_id}{the spe \code{colData} variable to mark the image}

\item{condition}{the spe \code{colData} variable to mark the condition}

\item{continuous}{A boolean indicating whether the marks are continuous
defaults to FALSE}

\item{assay}{the assay which is used if \code{continuous = TRUE}}

\item{transformation}{the transformation to be applied as exponential e.g.
1/2 for sqrt or Fisher's variance-stabilising transformation if "Fisher"}

\item{intensityAdjustment}{a logical whether or not to normalise out cell
type intensity differences in the functional regression model.
For $L$ functions the intensity effects is already explicit in the metric
definition. The intensity adjustement is via the average intensity of the
query cell type B in a cross (A->B) setting parametrised as a constant
covariate over the domain $r$. The "default" normalises $G$ and $F$ functions
like this but not all other functions.}

\item{weights}{the weighting to be applied to the functional GAM. Either NULL
(equal weights), total (npoints of total pattern), min (npoints of the smaller
subpattern) or max (npoints of the larger subpattern) or a user defined value
of same length as the number of curves to be estimated}

\item{eps}{some distributional families fail if the response is zero,
therefore, zeros can be replaced with a very small value eps}

\item{delta}{the delta value to remove from the beginning of the spatial
statistics functions. Can be reasonable if e.g. cells are always spaced
by 10 µm. If set to "minNnDist" it will take the mean of the minimum nearest
neighbour distance across all images for this cell type pair.}

\item{family}{the distributional family for the functional GAM}

\item{verbose}{logical indicating whether to print all information or not}

\item{upperDeltaProb}{the quantile to filter out the constant 1 part for \code{Gest}
and \code{Gcross}. If \code{NULL} no upper filtering is applied.}

\item{weightTransform}{logical indicating whether the weights (number of points)
should be sqrt transformed}

\item{AR1}{logical indicating whether to calculate the autocorrelation of the
residuals along the domain and account for this in a second fitting step}

\item{sandwich}{string indicating how and if to adjust for heterscedasticity of the
residuals with a sandwich correction}

\item{ncores}{the number of cores to use for parallel processing, default = 1}

\item{algorithm}{algorithm to fit the refund::pffr method. defaults to \code{bam}}

\item{...}{Other parameters passed to \code{spatstat.explore} functions for
parameters concerning the spatial function calculation and to \code{refund::pffr}
for the functional additive mixed model inference}
}
\value{
a list with four objects: i) the dataframe with the spatial
statistics results transformed and filtered as used for fitting,
ii) the raw spatial statistics results, iii) the designmatrix of the
inference and iv) the fitted pffr object v) the residual standard error per
condition defined as the residual sum of squares divided by the number of
datapoints - sum of the estimated degrees of freedom for the model parameters
as well as other QC metrics
}
\description{
A function to perform spatial statistical inference on spatial omics data.
This function works so far only on functions of radius "r".
}
\examples{
spe <- .loadExample()
#make the condition a factor variable
colData(spe)[["patient_stage"]] <- factor(colData(spe)[["patient_stage"]])
#relevel to have non-diabetic as the reference category
colData(spe)[["patient_stage"]] <- relevel(colData(spe)[["patient_stage"]],
"Non-diabetic")
res <- spatialInference(spe, c("alpha", "Tc"),
    fun = "Gcross", marks = "cell_type",
    rSeq = seq(0, 50, length.out = 50), correction = "rs",
    sample_id = "patient_id",
    image_id = "image_number", condition = "patient_stage",
    ncores = 1,
    algorithm = "bam"
)
}
